<!-- The [Include] tag includes another file within the flow of the page, and is described in Chapter 20 of the Lasso 7 Language Guide PDF. -->

[Include:'header.lasso']

<!-- Note: The source code for the "Lasso Security Status" box is contained in header.lasso -->

<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
 <tr>
  <td>
  <h2>Database Interaction Pages</h2>
   
  <p>The following link requires the "Example" database and permissions to be set up according to Chapter 11 of the Lasso Professional 7 Setup Guide. </p> 
   
  <p><strong><a href="search.lasso">Search, List, and Display Data</a></strong></p>

  </td>
 </tr>
</table>
<br>
<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
 <tr>
  <td>
  <h2>Database Interaction Pages (Password-Protected)</h2>
   
  <p>The following links require the "Example" database and permissions to be set up according to Chapter 11 of the Lasso Professional 7 Setup Guide. </p> 
     
  <p><strong><a href="list.lasso">List, Update, and Display Data</a></strong></p>
  
  <p><strong><a href="add.lasso">Add and Display Data</a></strong></p>

  </td>
 </tr>
</table>
<br>
<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
 <tr>
  <td>
  <h2>Miscellaneous Information</h2>
  
	<!-- Date and time operations are described in Chapter 16 of the Lasso 7 Language Guide. -->  
  
    <p><strong>Today's Date</strong>: [Date_Format: (Date), -Format='%B %m, %Y %r']</p>
    
    <!-- Client and server operations are described in Chapter 27 of the Lasso 7 Language Guide. -->
	
	<p><strong>Your IP Address</strong>: [Client_IP]</p>
	
	<p><strong>Your Browser</strong>: [Client_Browser]</p>
	
	<p><strong>Server Name</strong>: [Server_Name]</p>
	
	<!-- String concatenation (adding objects together) is discussed in Chapter 4 of the Language Guide. -->
	
	<p><strong>Current Page</strong>: ['http://' + (Server_Name) + (Response_FilePath)]</p>
	
	<p><strong>Random Word</strong>: 
	
	<?LassoScript
	
	// LassoScript is an alternate form of LDML syntax. For more info, see chapter 24 of the Lasso 7 Language Guide.
	
	Var:'Wordlist'=(Array: 'Panther', 'Foosball', 'Alligator', 'Origami', 'Taco', 'Fortified', 'Frisbee');
	
	Var:'Random_Num'=(Math_Random: -Min=1, -Max=$Wordlist->Size + 1);
	
	Output: $Wordlist->(Get: $Random_Num);
	
	?>
	
	</p>
  </td>
 </tr>
</table>

[Include:'footer.lasso']

