<!-- The UpdateResponse.lasso page is similar to the AddResponse.lasso page, but performs either an -Update or -Delete action in the opening [Inline] tag depending on the button that was selected in a preceding update form. -->

[Auth]

[Include:'header.lasso']

<form action="undefined" method="POST">
	<table bgcolor="#FFFFFF" cellspacing="1" cellpadding="5" width="550" border="0">
		<tr>
			<td colspan="2"> <h2>Update Response</b></h2>
			
	<!-- The [If] and [Inline] LDML objects perform an -Update or -Delete action on the database depending on the button selected in a preceding Update.lasso page. -->		
			
	[If: (Token_Value: 'Action') >> 'Delete'][Variable: 'Action'=-Delete][Else][Variable: 'Action'=-Update][/If]
	[Inline: (Action_Params), -Database='Example_DB', -Table='web', -KeyField='id', $Action]
 </td>
		</tr>
		<tr>
			<td colspan="2"> 	
			
		<!-- An [If] statement is used to display an error message if an error occurs when updating or deleting the record, or a confirmation message if the record is deleted. The [Error_CurrentError] tag displays the current Lasso error message. -->	
			
			[If: (Error_CurrentError) != (Error_NoError)]An error has occurred. ([Error_CurrentError: -ErrorCode] [Error_CurrentError])
	[Else: (Lasso_CurrentAction) == 'delete']<font color="red">This record was successfully deleted.</font>[/If]
	[/Inline]
 </td>
		</tr>
		
		<!-- Record data is displayed via [Action_Param] LDML objects, which display the values submitted in the preceding form that were updated in the database. -->
		
		<tr>
			<td><b> id </b></td>
			<td> [Action_Param: 'id'] </td>
		</tr>
		<tr>
			<td><b> address </b></td>
			<td> [Action_Param: 'address'] </td>
		</tr>
		<tr>
			<td><b> city </b></td>
			<td> [Action_Param: 'city'] </td>
		</tr>
		<tr>
			<td><b> company </b></td>
			<td> [Action_Param: 'company'] </td>
		</tr>
		<tr>
			<td><b> description </b></td>
			<td> [Action_Param: 'description'] </td>
		</tr>
		<tr>
			<td><b> phone </b></td>
			<td> [Action_Param: 'phone'] </td>
		</tr>
		<tr>
			<td><b> state </b></td>
			<td> [Action_Param: 'state'] </td>
		</tr>
		<tr>
			<td><b> url </b></td>
			<td> [Action_Param: 'url'] </td>
		</tr>
		<tr>
			<td><b> zip </b></td>
			<td> [Action_Param: 'zip'] </td>
		</tr>
		<tr>
			<td><b> country </b></td>
			<td> [Action_Param: 'country'] </td>
		</tr>
		<tr>
			<td colspan="2">  </td>
		</tr>
	</table>
</form>

[Include:'footer.lasso']
