<?LassoScript
	auth_admin;
	include: (lassoapp_link: 'library.lasso');
?>
<html>
	<head>
		<title>[var: 'admin_title', -encodenone]</title>
		<link rel="Stylesheet" href="[lassoapp_link: 'default.css']" />

		<script language="JavaScript">
			function showhelp(url)
			{
				window.open(url,'help','status=no,menubar=no,scrollbars=yes,resizable=yes,width=472,height=356');
				return false;
			}
		</script>

[inline: (action_params), -nothing, -database='lasso_internal']
		
	<?LassoScript

		// This variable holds the default tab for each section
		_admin_addvar: -name='admin_memory', -session='_admin', -default=(map);
	
		// Library One
		
		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_memory->(find: '_root');
		/If;
		If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
			var: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
		/If;
		$admin_memory->(insert: '_root' = $admin_tab1);
	
		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/library.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
	
		// Library Two

		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = $admin_memory->(find: $admin_tab1);
		/If;
		If: ($admin_tab2 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2) == 'None';
			variable: 'admin_tab2' = (_admin_array_find: $admin_tab_array2, $admin_tab1)->(get:1)->first;
		/If;
		$admin_memory->(insert: $admin_tab1 = $admin_tab2);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/library.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;	
		
		// Library Three

		If: ($admin_tab3 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3) == 'None';
			variable: 'admin_tab3' = $admin_memory->(find: $admin_tab1 + ':' + $admin_tab2);
		/If;
		If: ($admin_tab3 == '') || (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3) == 'None';
			variable: 'admin_tab3' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)->(get:1)->first;
		/If;
		$admin_memory->(insert: ($admin_tab1 + ':' + $admin_tab2) = $admin_tab3);

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/library.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError: -encodebreaks) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;	
	

		// Export Overrides
		
		if: ($admin_tab1 == 'setup') && ($admin_tab2 == 'global') && ($admin_tab3 == 'importexport') && ((action_param: 'view') == 'export');
	
			Protect;
				Error_SetErrorCode: (Error_NoError: -ErrorCode);
				Error_SetErrorMessage: (Error_NoError);
				var: '__html_reply__' = (include: (admin_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/export.lasso')));
				Abort;
			/Protect;
				
		/if;

		// Reset admin_link based on actual tab visited
		
		var: 'admin_link' = $admin_file +
			'?tab1=' + $admin_tab1 +
			'&tab2=' + $admin_tab2 +
			'&tab3=' + $admin_tab3 +
			'&-session=_admin:' + (session_id: -name='_admin') +
			'&increment=' + $admin_increment;
	?>
	
	[if: ((var: 'admin_refresh') == true)]
		<meta http-equiv="refresh" content="60; url=[var: 'admin_link', -encodenone]">
	[/if]
	
	</head>
	
	<body bgcolor="#FFFFFF">
	
	<div align="center">
	  <table width="836" border="0" cellspacing="0" cellpadding="0">
		<tr>
		  <td align="left" width="144"><a class="tab" href="[admin_link: 'default.lasso']?logout=true"><img src="[admin_link:'images/LP7_WhiteLogo.gif']" width="144" height="36" border="0"></a></td>
		  <td align="center" valign="bottom" width="548">
			<table width="480" border="0" cellspacing="0" cellpadding="0">
			  <tr align="center">
				<td width="[math_floor: (100 - $admin_tab_array1->size * (math_min: (integer: 100 / $admin_tab_array1->size), 25)) / 2]%">&nbsp;</td>[Iterate: $admin_tab_array1, (Variable: 'tab_temp')][If: $tab_temp->First == $admin_tab1]
				<td bgcolor="#999999" width="6" align="left"><img src="[admin_link: 'Images/tab1_enabled_left.gif']" width="6" height="24"></td>
				<td bgcolor="#999999" nowrap width="[math_min: (math_floor: 100 / $admin_tab_array1->size), 25]%"><font size="2"><a class="tab" href="[var: 'admin_file']?tab1=[Output: $tab_temp->First]&-session=_admin:[session_id: -name='_admin']&increment=[var: 'admin_increment']"><b>[output: $tab_temp->Second]</b></a></font></td>
				<td bgcolor="#999999" width="6" align="right"><img src="[admin_link: 'Images/tab1_enabled_right.gif']" width="6" height="24"></td>
			  [else]
				<td bgcolor="#cccccc" width="6" align="left"><img src="[admin_link: 'Images/tab1_disabled_left.gif']" width="6" height="24"></td>
				<td bgcolor="#cccccc" nowrap width="[math_min: (math_floor: 100 / $admin_tab_array1->size), 25]%"><font size="2"><a class="tab" href="[var: 'admin_file']?tab1=[Output: $tab_temp->First]&-session=_admin:[session_id: -name='_admin']&increment=[var: 'admin_increment']"><b>[output: $tab_temp->Second]</b></a></font></td>
				<td bgcolor="#cccccc" width="6" align="right"><img src="[admin_link: 'Images/tab1_disabled_right.gif']" width="6" height="24"></td>
			  [/if][/Iterate]
				<td width="[math_floor: (100 - $admin_tab_array1->size * (math_min: (integer: 100 / $admin_tab_array1->size), 25)) / 2]%">&nbsp;</td>
			  </tr>
			</table>
		  </td>
		  <td align="right" width="144"><a href="http://www.blueworld.com/"><img src="[admin_link:'images/logo_right.jpg']" width="144" height="36" border="0"></a></td>
		</tr>
[if: ($admin_tab1 != 'login')]
		<tr valign="bottom" align="center">
		  <td colspan="3" height="24" bgcolor="#999999">
			<table width="836" height="20" border="0" cellspacing="0" cellpadding="0">
			  <tr align="center">
				<td bgcolor="#999999" width="6">&nbsp;</td>
			  [Variable: 'temp_array' = (_admin_array_find: $admin_tab_array2, $admin_tab1)][Iterate: $temp_array, (Variable: 'tab_temp')][if: $admin_tab_disabled2 >> $tab_temp->first]
				<td bgcolor="#999999" width="6" align="left"><img src="[admin_link: 'Images/tab2_disabled_left.gif']" width="6" height="20"></td>
				<td bgcolor="#999999" nowrap width="[math_min: (math_floor: 100 / $temp_array->size), 16]%"><font size="1" color="#666666">[output: $tab_temp->Second]</font></td>
				<td bgcolor="#999999" width="6" align="right"><img src="[admin_link: 'Images/tab2_disabled_right.gif']" width="6" height="20"></td>
			  [else: $tab_temp->First == $admin_tab2]
				<td bgcolor="#cccccc" width="6" align="left"><img src="[admin_link: 'Images/tab2_enabled_left.gif']" width="6" height="20"></td>
				<td bgcolor="#cccccc" nowrap width="[math_min: (math_floor: 100 / $temp_array->size), 16]%"><font size="1"><a class="tab" href="[var: 'admin_file']?tab1=[Variable: 'admin_tab1']&tab2=[Output: $tab_temp->First]&-session=_admin:[session_id: -name='_admin']&increment=[var: 'admin_increment']"><b>[output: $tab_temp->Second]</b></a></font></td>
				<td bgcolor="#cccccc" width="6" align="right"><img src="[admin_link: 'Images/tab2_enabled_right.gif']" width="6" height="20"></td>
			  [else]
				<td bgcolor="#999999" width="6" align="left"><img src="[admin_link: 'Images/tab2_disabled_left.gif']" width="6" height="20"></td>
				<td bgcolor="#999999" nowrap width="[math_min: (math_floor: 100 / $temp_array->size), 16]%"><font size="1"><a class="tab" href="[var: 'admin_file']?tab1=[Variable: 'admin_tab1']&tab2=[Output: $tab_temp->First]&-session=_admin:[session_id: -name='_admin']&increment=[var: 'admin_increment']">[output: $tab_temp->Second]</a></font></td>
				<td bgcolor="#999999" width="6" align="right"><img src="[admin_link: 'Images/tab2_disabled_right.gif']" width="6" height="20"></td>
			  [/if][/Iterate]
				<td width="[math_floor: (100 - $temp_array->size * (math_min: (math_floor: 100 / $temp_array->size), 16))]%">&nbsp;</td>
				<td bgcolor="#999999" width="6">&nbsp;</td>
			  </tr>
			</table>
		  </td>
		</tr>
		<tr valign="bottom" align="center">
		  <td colspan="3" height="24" bgcolor="#cccccc">
			<table width="836" height="20" border="0" cellspacing="0" cellpadding="0">
			  <tr align="center">
				<td bgcolor="#cccccc" width="6">&nbsp;</td>
			  [Variable: 'temp_array' = (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2)][Iterate: $temp_array, (Variable: 'tab_temp')][if: $admin_tab_disabled3 >> $tab_temp->first]
				<td bgcolor="#cccccc" width="6" align="left"><img src="[admin_link: 'Images/tab3_disabled_left.gif']" width="6" height="20"></td>
				<td bgcolor="#cccccc" nowrap width="[math_min: (math_floor: 100 / $temp_array->size), 16]%"><font size="1" color="#666666">[output: $tab_temp->Second]</font></td>
				<td bgcolor="#cccccc" width="6" align="right"><img src="[admin_link: 'Images/tab3_disabled_right.gif']" width="6" height="20"></td>
			  [else: $tab_temp->First == $admin_tab3]
				<td bgcolor="#eeeeee" width="6" align="left"><img src="[admin_link: 'Images/tab3_enabled_left.gif']" width="6" height="20"></td>
				<td bgcolor="#eeeeee" nowrap width="[math_min: (math_floor: 100 / $temp_array->size), 16]%"><font size="1"><a class="tab" href="[var: 'admin_file']?tab1=[Variable: 'admin_tab1']&tab2=[Variable: 'admin_tab2']&tab3=[Output: $tab_temp->First]&-session=_admin:[session_id: -name='_admin']&increment=[var: 'admin_increment']"><b>[output: $tab_temp->Second]</b></a></font></td>
				<td bgcolor="#eeeeee" width="6" align="right"><img src="[admin_link: 'Images/tab3_enabled_right.gif']" width="6" height="20"></td>
			  [else]
				<td bgcolor="#cccccc" width="6" align="left"><img src="[admin_link: 'Images/tab3_disabled_left.gif']" width="6" height="20"></td>
				<td bgcolor="#cccccc" nowrap width="[math_min: (math_floor: 100 / $temp_array->size), 16]%"><font size="1"><a class="tab" href="[var: 'admin_file']?tab1=[Variable: 'admin_tab1']&tab2=[Variable: 'admin_tab2']&tab3=[Output: $tab_temp->First]&-session=_admin:[session_id: -name='_admin']&increment=[var: 'admin_increment']">[output: $tab_temp->Second]</a></font></td>
				<td bgcolor="#cccccc" width="6" align="right"><img src="[admin_link: 'Images/tab3_disabled_right.gif']" width="6" height="20"></td>
			  [/if][/Iterate]
				<td width="[math_floor: (100 - $temp_array->size * (math_min: (math_floor: 100 / $temp_array->size), 16))]%">&nbsp;</td>
				<td bgcolor="#cccccc" width="6">&nbsp;</td>
			  </tr>
			</table>
		  </td>
		</tr>
[else]
		<tr valign="bottom" align="center">
		  <td colspan="3" height="12" bgcolor="#999999"></td>
	    </tr>
[/if]
		<tr>
		  <td colspan="3" bgcolor="#EEEEEE">
	
	<?LassoScript
	
		// Default One

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/default.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
	
		// Default Two

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/default.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
		
		// Default Three

		Protect;
			Error_SetErrorCode: (Error_NoError: -ErrorCode);
			Error_SetErrorMessage: (Error_NoError);
			Include: (admin_link: (string:  $admin_tab1 + '/' + $admin_tab2 + '/' + $admin_tab3 + '/default.lasso'));
			Handle: ((Error_CurrentError) != (Error_NoError)) && ((Error_CurrentError: -ErrorCode) != (Error_NoError: -ErrorCode)) && ((Error_CurrentError: -ErrorCode) != (Error_FileNotFound: -ErrorCode));
				_debug: (Error_CurrentError) + ' (' + (Error_CurrentError: -ErrorCode) + ')', -EncodeNone;
			/Handle;
		/Protect;
		
	?>
	
[/inline]

		  </td>
		</tr>
		<tr align="center">
		  <td colspan="3" bgcolor="#999999">
			<table border="0" cellspacing="0" cellpadding="0" width="836" height="16">
			  <tr align="center">
				<td width="72"><font size="1"><b><a class="tab" href="[var: 'admin_link']&setup_action=refresh&browse_action=refresh">Refresh</a></b></font></td>
				<td><font size="1">Lasso Administration [lasso_version: -lassoversion][if: (var: 'admin_serialedition') != ''] &#149; [var: 'admin_serialedition'][/if][if: (var: 'admin_username') != ''] &#149; Current&nbsp;User:&nbsp;[Var: 'admin_username'][/if]</font></td>
				<td width="72"><font size="1"><b><a class="tab" href="[admin_link: 'default.lasso']?logout=true">Logout</a></b></font></td>
			  </tr>
			</table>
		  </td>
		</tr>
		<tr align="center" valign="bottom">
		  <td colspan="3" height="24">
			<table border="0" cellspacing="0" cellpadding="0" width="836" height="16">
			  <tr align="center" valign="bottom">
				<td align="left"><font size="1">&copy; 1996-[date->year] OmniPilot Software, Inc.</font></td>
				<td width="50%" align="right"><font size="1">&nbsp;</font></td>
			  </tr>
			  <tr align="center" valign="bottom">
				<td align="left"><br><a href="http://www.blueworld.com/"><img src="[admin_link: 'images/lassopower.gif']" height="52" width="81" border="0"></a></td>
				<td width="50%" align="right"><font size="1">&nbsp;</font></td>
			  </tr>
			</table>
		  </td>
		</tr>
	  </table>
	</div>
	</body>
</html>