<?LassoScript

	//
	// Custom Tags
	//
	include: (lassoapp_link: 'tags.lasso');

	//
	// Cache Control
	//
	_admin_nocache;
	
	//
	// Session
	//
	
	if: (action_param:'logout') == 'true';
		session_end: -name='_admin';
		redirect_url: 'logout.lasso';
	else;
		session_start: -name='_admin', -expires=1440, -usecookie;
		
		_admin_addvar: -session='_admin', -name='admin_datetime', -default=(string: date);
		_admin_addvar: -session='_admin', -name='admin_increment', -default='123453';
		_admin_addvar: -session='_admin', -name='admin_username', -override=(client_username), -default='';
		_admin_addvar: -session='_admin', -name='admin_ipaddress', -default=(string: _client_address_old);
		_admin_addvar: -session='_admin', -name='admin_usertype', -default='none';
	/if;
		
	var: 'admin_increment' = (integer: $admin_increment) + 3;
	//
	// Log In
	//

				var: 'login_required' = false;
	
	//
	// Serial Number
	//
	if: ((var_defined: 'admin_serialnum') == false) || ((var:'admin_serialnum') == '');
		var: 'admin_serialnum'='LP7-EVAL-1234567890ABCDE';
		inline: -search,
				-database='lasso_internal', 
				-table='serial_numbers', 
				-op='eq', 'id'='1', 
				-maxrecords=1;
			records;
				var: 'admin_serialnum' = (field:'serial');
			/records;
		/inline;
		var: 'admin_serialedition' = '';
	/if;
	
	if: (var_defined: 'admin_serialedition') == false || (var: 'admin_serialedition') == '';
		// Parse the Serial Number
		if: ($admin_serialnum >> 'LS7GL') || ($admin_serialnum >> 'LS7DW') || ($admin_serialnum >> 'LD7-MAC') || ($admin_serialnum >> 'LD7-WIN');
		  var: 'admin_serialedition'='Single-User';
		else: ($admin_serialnum >> 'LP7-WIN') || ($admin_serialnum >> 'LP7-MAC') || ($admin_serialnum >> 'LP7-LIN');
		  var: 'admin_serialedition'='Multi-User';
		else;
		  var: 'admin_serialtemp'=(_security_serialexpiration);
		  if: (var: 'admin_serialtemp') != '';
			  var: 'admin_serialedition'='Evaluation (Expires ' + $admin_serialtemp + ')';
		  else;
			  var: 'admin_serialedition'='Unknown';
		  /if;
		/if;
	/if;

	//
	// Tab Arrays
	//
	
	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);
	
		Variable: 'admin_tab_array1' = (Array:
			'setup'='Setup',
			'utility'='Utility',
			'support'='Support',
		);
		Variable: 'admin_tab_array2' = (Array:
			'setup'=(Array:
				'global'='Global',
				'datasources'='Data Sources',
				'security'='Security',
			),
			'utility'=(Array: 
				'sql'='SQL',
				'mysql'='Lasso MySQL',
				'email'='Email',
				'event'='Events',
				'errors'='Errors',
				'lassoapps'='LassoApps',
				'cache'='Cache',
			),
			'support'=(Array: 
				'blueworld'='OmniPilot',
				'ldml'='LDML Reference',
				'thirdparty'='Third-Party',
			),
		);
		Variable: 'admin_tab_array3' = (Array:
			'setup:global'=(Array:
				'login'='Admin',
				'syntax'='Settings',
				'files'='File Extensions',
				'sessions'='Sessions',
				'tags'='Tags',
				'java'='Java',
				'importexport'='Import/Export',
			),
			'setup:datasources'=(Array:
				'connectors'='Connectors',
				'host'='Hosts',
				'databases'='Databases',
				'tables'='Tables',
				'fields'='Fields',
			),
			'setup:security'=(Array:
				'groups'='Groups',
				'users'='Users',
				'hosts'='Hosts',
				'databases'='Databases',
				'tables'='Tables',
				'files'='Files',
				'tags'='Tags',
			),
			'utility:mysql'=(Array:
				'tables'='Maintenance',
				'restore'='Restore',
			),
			'utility:sql'=(Array:
				'browse'='Browser',
			),
			'utility:email'=(Array:
				'email'='Email Queue',
				'addemail'='Send Email',
				'setup'='Setup',
			),
			'utility:event'=(Array:
				'event'='Event Queue',
				'addevent'='Schedule Event',
			),
			'utility:errors'=(Array:
				'errors'='Lasso Errors',
				'setup'='Setup',
			),
			'utility:lassoapps'=(Array:
				'list'='List',
				'build'='Build',
				'setup'='Setup',
			),
			'utility:cache'=(Array:
				'list'='List',
				'setup'='Setup',
			),
			'support:blueworld'=(Array:
				'contact'='Contact',
			),
			'support:ldml'=(Array:
				'launch'='Local',
				'blueworld'='OmniPilot',
			),
			'support:thirdparty'=(Array:
				'contact'='Contact',
			),
		);

	// Current Tab
	
	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));

	// Default Tabs
	
	// Title
	
	var: 'admin_title' = 'Lasso Administration ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1);
	var: 'temp' = (_admin_array_find: $admin_tab_array1, $admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

	var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

	var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;
	/if;
		/if;
	/if;

	//
	// LassoApp Links
	//

	var: 'admin_link_map' = (map:
		'default.lasso' = (lassoapp_link: 'default.lasso'),
		'setup/datasources/connectors/default.lasso' = (lassoapp_link: 'setup/datasources/connectors/default.lasso'),
		'setup/datasources/connectors/dialog.lasso' = (lassoapp_link: 'setup/datasources/connectors/dialog.lasso'),
		'setup/datasources/connectors/library.lasso' = (lassoapp_link: 'setup/datasources/connectors/library.lasso'),
		'setup/datasources/databases/default.lasso' = (lassoapp_link: 'setup/datasources/databases/default.lasso'),
		'setup/datasources/databases/dialog.lasso' = (lassoapp_link: 'setup/datasources/databases/dialog.lasso'),
		'setup/datasources/databases/library.lasso' = (lassoapp_link: 'setup/datasources/databases/library.lasso'),
		'setup/datasources/fields/default.lasso' = (lassoapp_link: 'setup/datasources/fields/default.lasso'),
		'setup/datasources/fields/dialog.lasso' = (lassoapp_link: 'setup/datasources/fields/dialog.lasso'),
		'setup/datasources/fields/library.lasso' = (lassoapp_link: 'setup/datasources/fields/library.lasso'),
		'setup/datasources/host/default.lasso' = (lassoapp_link: 'setup/datasources/host/default.lasso'),
		'setup/datasources/host/dialog.lasso' = (lassoapp_link: 'setup/datasources/host/dialog.lasso'),
		'setup/datasources/host/library.lasso' = (lassoapp_link: 'setup/datasources/host/library.lasso'),
		'setup/datasources/library.lasso' = (lassoapp_link: 'setup/datasources/library.lasso'),
		'setup/datasources/search/default.lasso' = (lassoapp_link: 'setup/datasources/search/default.lasso'),
		'setup/datasources/search/dialog.lasso' = (lassoapp_link: 'setup/datasources/search/dialog.lasso'),
		'setup/datasources/search/library.lasso' = (lassoapp_link: 'setup/datasources/search/library.lasso'),
		'setup/datasources/tables/default.lasso' = (lassoapp_link: 'setup/datasources/tables/default.lasso'),
		'setup/datasources/tables/dialog.lasso' = (lassoapp_link: 'setup/datasources/tables/dialog.lasso'),
		'setup/datasources/tables/library.lasso' = (lassoapp_link: 'setup/datasources/tables/library.lasso'),
		'setup/global/files/default.lasso' = (lassoapp_link: 'setup/global/files/default.lasso'),
		'setup/global/files/dialog.lasso' = (lassoapp_link: 'setup/global/files/dialog.lasso'),
		'setup/global/files/library.lasso' = (lassoapp_link: 'setup/global/files/library.lasso'),
		'setup/global/importexport/default.lasso' = (lassoapp_link: 'setup/global/importexport/default.lasso'),
		'setup/global/importexport/dialog.lasso' = (lassoapp_link: 'setup/global/importexport/dialog.lasso'),
		'setup/global/importexport/dialog_results.lasso' = (lassoapp_link: 'setup/global/importexport/dialog_results.lasso'),
		'setup/global/importexport/export.lasso' = (lassoapp_link: 'setup/global/importexport/export.lasso'),
		'setup/global/importexport/library.lasso' = (lassoapp_link: 'setup/global/importexport/library.lasso'),
		'setup/global/java/default.lasso' = (lassoapp_link: 'setup/global/java/default.lasso'),
		'setup/global/java/dialog.lasso' = (lassoapp_link: 'setup/global/java/dialog.lasso'),
		'setup/global/java/library.lasso' = (lassoapp_link: 'setup/global/java/library.lasso'),
		'setup/global/login/default.lasso' = (lassoapp_link: 'setup/global/login/default.lasso'),
		'setup/global/login/dialog_password.lasso' = (lassoapp_link: 'setup/global/login/dialog_password.lasso'),
		'setup/global/login/dialog_serial.lasso' = (lassoapp_link: 'setup/global/login/dialog_serial.lasso'),
		'setup/global/login/library.lasso' = (lassoapp_link: 'setup/global/login/library.lasso'),
		'setup/global/sessions/default.lasso' = (lassoapp_link: 'setup/global/sessions/default.lasso'),
		'setup/global/sessions/dialog.lasso' = (lassoapp_link: 'setup/global/sessions/dialog.lasso'),
		'setup/global/sessions/library.lasso' = (lassoapp_link: 'setup/global/sessions/library.lasso'),
		'setup/global/syntax/default.lasso' = (lassoapp_link: 'setup/global/syntax/default.lasso'),
		'setup/global/syntax/dialog.lasso' = (lassoapp_link: 'setup/global/syntax/dialog.lasso'),
		'setup/global/syntax/library.lasso' = (lassoapp_link: 'setup/global/syntax/library.lasso'),
		'setup/global/tags/default.lasso' = (lassoapp_link: 'setup/global/tags/default.lasso'),
		'setup/global/tags/dialog.lasso' = (lassoapp_link: 'setup/global/tags/dialog.lasso'),
		'setup/global/tags/library.lasso' = (lassoapp_link: 'setup/global/tags/library.lasso'),
		'setup/security/databases/default.lasso' = (lassoapp_link: 'setup/security/databases/default.lasso'),
		'setup/security/databases/dialog.lasso' = (lassoapp_link: 'setup/security/databases/dialog.lasso'),
		'setup/security/databases/library.lasso' = (lassoapp_link: 'setup/security/databases/library.lasso'),
		'setup/security/files/default.lasso' = (lassoapp_link: 'setup/security/files/default.lasso'),
		'setup/security/files/library.lasso' = (lassoapp_link: 'setup/security/files/library.lasso'),
		'setup/security/groups/default.lasso' = (lassoapp_link: 'setup/security/groups/default.lasso'),
		'setup/security/groups/dialog.lasso' = (lassoapp_link: 'setup/security/groups/dialog.lasso'),
		'setup/security/groups/library.lasso' = (lassoapp_link: 'setup/security/groups/library.lasso'),
		'setup/security/hosts/default.lasso' = (lassoapp_link: 'setup/security/hosts/default.lasso'),
		'setup/security/hosts/dialog.lasso' = (lassoapp_link: 'setup/security/hosts/dialog.lasso'),
		'setup/security/hosts/library.lasso' = (lassoapp_link: 'setup/security/hosts/library.lasso'),
		'setup/security/library.lasso' = (lassoapp_link: 'setup/security/library.lasso'),
		'setup/security/tables/default.lasso' = (lassoapp_link: 'setup/security/tables/default.lasso'),
		'setup/security/tables/dialog.lasso' = (lassoapp_link: 'setup/security/tables/dialog.lasso'),
		'setup/security/tables/library.lasso' = (lassoapp_link: 'setup/security/tables/library.lasso'),
		'setup/security/tags/default.lasso' = (lassoapp_link: 'setup/security/tags/default.lasso'),
		'setup/security/tags/dialog.lasso' = (lassoapp_link: 'setup/security/tags/dialog.lasso'),
		'setup/security/tags/library.lasso' = (lassoapp_link: 'setup/security/tags/library.lasso'),
		'setup/security/users/default.lasso' = (lassoapp_link: 'setup/security/users/default.lasso'),
		'setup/security/users/dialog.lasso' = (lassoapp_link: 'setup/security/users/dialog.lasso'),
		'setup/security/users/library.lasso' = (lassoapp_link: 'setup/security/users/library.lasso'),
		'utility/cache/list/default.lasso' = (lassoapp_link: 'utility/cache/list/default.lasso'),
		'utility/cache/list/library.lasso' = (lassoapp_link: 'utility/cache/list/library.lasso'),
		'utility/cache/setup/default.lasso' = (lassoapp_link: 'utility/cache/setup/default.lasso'),
		'utility/cache/setup/library.lasso' = (lassoapp_link: 'utility/cache/setup/library.lasso'),
		'utility/email/addemail/default.lasso' = (lassoapp_link: 'utility/email/addemail/default.lasso'),
		'utility/email/addemail/library.lasso' = (lassoapp_link: 'utility/email/addemail/library.lasso'),
		'utility/email/email/default.lasso' = (lassoapp_link: 'utility/email/email/default.lasso'),
		'utility/email/email/dialog.lasso' = (lassoapp_link: 'utility/email/email/dialog.lasso'),
		'utility/email/email/library.lasso' = (lassoapp_link: 'utility/email/email/library.lasso'),
		'utility/email/search/default.lasso' = (lassoapp_link: 'utility/email/search/default.lasso'),
		'utility/email/search/library.lasso' = (lassoapp_link: 'utility/email/search/library.lasso'),
		'utility/email/setup/default.lasso' = (lassoapp_link: 'utility/email/setup/default.lasso'),
		'utility/email/setup/library.lasso' = (lassoapp_link: 'utility/email/setup/library.lasso'),
		'utility/errors/errors/default.lasso' = (lassoapp_link: 'utility/errors/errors/default.lasso'),
		'utility/errors/errors/dialog.lasso' = (lassoapp_link: 'utility/errors/errors/dialog.lasso'),
		'utility/errors/errors/library.lasso' = (lassoapp_link: 'utility/errors/errors/library.lasso'),
		'utility/errors/search/default.lasso' = (lassoapp_link: 'utility/errors/search/default.lasso'),
		'utility/errors/search/library.lasso' = (lassoapp_link: 'utility/errors/search/library.lasso'),
		'utility/errors/setup/default.lasso' = (lassoapp_link: 'utility/errors/setup/default.lasso'),
		'utility/errors/setup/library.lasso' = (lassoapp_link: 'utility/errors/setup/library.lasso'),
		'utility/event/addevent/default.lasso' = (lassoapp_link: 'utility/event/addevent/default.lasso'),
		'utility/event/addevent/library.lasso' = (lassoapp_link: 'utility/event/addevent/library.lasso'),
		'utility/event/event/default.lasso' = (lassoapp_link: 'utility/event/event/default.lasso'),
		'utility/event/event/dialog.lasso' = (lassoapp_link: 'utility/event/event/dialog.lasso'),
		'utility/event/event/library.lasso' = (lassoapp_link: 'utility/event/event/library.lasso'),
		'utility/lassoapps/build/default.lasso' = (lassoapp_link: 'utility/lassoapps/build/default.lasso'),
		'utility/lassoapps/build/library.lasso' = (lassoapp_link: 'utility/lassoapps/build/library.lasso'),
		'utility/lassoapps/list/default.lasso' = (lassoapp_link: 'utility/lassoapps/list/default.lasso'),
		'utility/lassoapps/list/library.lasso' = (lassoapp_link: 'utility/lassoapps/list/library.lasso'),
		'utility/lassoapps/setup/default.lasso' = (lassoapp_link: 'utility/lassoapps/setup/default.lasso'),
		'utility/lassoapps/setup/library.lasso' = (lassoapp_link: 'utility/lassoapps/setup/library.lasso'),
		'utility/mysql/restore/default.lasso' = (lassoapp_link: 'utility/mysql/restore/default.lasso'),
		'utility/mysql/restore/dialog.lasso' = (lassoapp_link: 'utility/mysql/restore/dialog.lasso'),
		'utility/mysql/restore/library.lasso' = (lassoapp_link: 'utility/mysql/restore/library.lasso'),
		'utility/mysql/tables/default.lasso' = (lassoapp_link: 'utility/mysql/tables/default.lasso'),
		'utility/mysql/tables/dialog.lasso' = (lassoapp_link: 'utility/mysql/tables/dialog.lasso'),
		'utility/mysql/tables/library.lasso' = (lassoapp_link: 'utility/mysql/tables/library.lasso'),
		'utility/sql/browse/default.lasso' = (lassoapp_link: 'utility/sql/browse/default.lasso'),
		'utility/sql/browse/library.lasso' = (lassoapp_link: 'utility/sql/browse/library.lasso'),
		'support/blueworld/contact/default.lasso' = (lassoapp_link: 'support/blueworld/contact/default.lasso'),
		'support/blueworld/contact/library.lasso' = (lassoapp_link: 'support/blueworld/contact/library.lasso'),
		'support/ldml/blueworld/default.lasso' = (lassoapp_link: 'support/ldml/blueworld/default.lasso'),
		'support/ldml/blueworld/library.lasso' = (lassoapp_link: 'support/ldml/blueworld/library.lasso'),
		'support/ldml/launch/default.lasso' = (lassoapp_link: 'support/ldml/launch/default.lasso'),
		'support/ldml/launch/library.lasso' = (lassoapp_link: 'support/ldml/launch/library.lasso'),
		'support/thirdparty/contact/default.lasso' = (lassoapp_link: 'support/thirdparty/contact/default.lasso'),
		'support/thirdparty/contact/library.lasso' = (lassoapp_link: 'support/thirdparty/contact/library.lasso'),
		'images/LP7_WhiteLogo.gif' = (lassoapp_link: 'images/LP7_WhiteLogo.gif'),
		'images/logo_right.jpg' = (lassoapp_link: 'images/logo_right.jpg'),		
		'images/tab1_enabled_left.gif' = (lassoapp_link: 'images/tab1_enabled_left.gif'),		
		'images/tab1_enabled_right.gif' = (lassoapp_link: 'images/tab1_enabled_right.gif'),		
		'images/tab1_disabled_left.gif' = (lassoapp_link: 'images/tab1_disabled_left.gif'),		
		'images/tab1_disabled_right.gif' = (lassoapp_link: 'images/tab1_disabled_right.gif'),		
		'images/tab2_enabled_left.gif' = (lassoapp_link: 'images/tab2_enabled_left.gif'),		
		'images/tab2_enabled_right.gif' = (lassoapp_link: 'images/tab2_enabled_right.gif'),		
		'images/tab2_disabled_left.gif' = (lassoapp_link: 'images/tab2_disabled_left.gif'),		
		'images/tab2_disabled_right.gif' = (lassoapp_link: 'images/tab2_disabled_right.gif'),		
		'images/tab3_enabled_left.gif' = (lassoapp_link: 'images/tab3_enabled_left.gif'),		
		'images/tab3_enabled_right.gif' = (lassoapp_link: 'images/tab3_enabled_right.gif'),		
		'images/tab3_disabled_left.gif' = (lassoapp_link: 'images/tab3_disabled_left.gif'),		
		'images/tab3_disabled_right.gif' = (lassoapp_link: 'images/tab3_disabled_right.gif'),		
		'images/lassopower.gif' = (lassoapp_link: 'images/lassopower.gif'),		
	);
	
	define_tag: 'admin_link', -required='link';
		if: $admin_link_map->(find: #link) != null;
			return: $admin_link_map->(find: #link);
		else;
			return: (lassoapp_link: #link);
		/if;
	/define_tag;
	
	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link:'default.lasso');
	/if;
	
	if:(var_defined:'dialog_file')==false;
		var:'dialog_file'=(LassoApp_Link: 'dialog.lasso');
	/if;

	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&tab2=' + $admin_tab2 +
		'&tab3=' + $admin_tab3 +
		'&-session=_admin:' + (session_id: -name='_admin') +
		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';

?>
