<?LassoScript

//
// Variables
//

_admin_addvar: 'mysql_connectorid', -default='1', -session='_admin', -override=(action_param: 'mysql_connectorid');
_admin_addvar: 'mysql_hostid', -session='_admin', -override=(action_param: 'mysql_hostid');
_admin_addvar: 'mysql_databaseid', -session='_admin', -override=(action_param: 'mysql_databaseid');
_admin_addvar: 'mysql_tableid', -session='_admin', -override=(action_param: 'mysql_tableid');

_admin_addvar: 'mysql_action', -default='None', -override=(action_param: 'mysql_action', (action_param: 'mysql_action', -count));
_admin_addvar: 'mysql_batchaction', -session='_admin', -override=(action_param: 'mysql_batchaction');
_admin_addvar: 'mysql_table_skip', -default=1, -session='_admin', -override=(action_param: 'mysql_table_skip');
_admin_addvar: 'mysql_navigation', -override=(action_param: 'mysql_navigation');
_admin_addvar: 'mysql_jump', -override=(action_param: 'mysql_jump');

_admin_addvar: 'mysql_checked', -session='_admin', -override=(array);
_admin_addvar: 'mysql_checkaction', -override=(action_param: 'mysql_checkaction');

var: 'mysql_checked' = (array);
loop: (action_param: 'mysql_checked', -count); $mysql_checked->(insert: (action_param: 'mysql_checked', loop_count)); /loop;

_admin_addvar: 'database_name', -override=(action_param: 'database_name');
_admin_addvar: 'database_alias', -override=(action_param: 'database_alias');
_admin_addvar: 'table_name', -override=(action_param: 'table_name');

_admin_addvar: 'mysql_scheduleaction', -session='_admin', -default='none';

//
// Build Menus
//

var: 'mysql_connectormap' = (array);
var: 'mysql_hostmap' = (array);
var: 'mysql_databasemap' = (array);
var: 'mysql_tablemap' = (array);

if: ($mysql_action >> 'Refresh') && ($mysql_connectorid != 0);
	_admin_refreshsecurity;
/if;

var: 'mysql_connectormap' = (_admin_listconnectors);
var: 'temp' = $mysql_connectormap->(get:1);
if: ($temp != null);
	var: 'mysql_connectorid' = $temp->first;
	var: 'mysql_connectordetail' = $temp->second;
	var: 'mysql_connectoralias' = $mysql_connectordetail->(find: 'alias');
else;
	var: 'mysql_connectorid' = 0;
	var: 'mysql_connectordetail' = null;
/if;

if: ($mysql_action >> 'Refresh') && ($mysql_connectorid != 0);
	_admin_refreshconnector: $mysql_connectorid;
/if;

if: ($mysql_connectorid > 0);
	var: 'mysql_hostmap' = (_admin_listhosts: $mysql_connectorid);
	var: 'temp' = (_admin_defaulthost: $mysql_hostid, $mysql_hostmap);
	if: ($temp != null);
		var: 'mysql_hostid' = $temp->first;
		var: 'mysql_hostdetail' = $temp->second;
	else;
		var: 'mysql_hostid' = 0;
		var: 'mysql_hostdetail' = null;
	/if;
else;
	var: 'mysql_hostid' = 0;
	var: 'mysql_hostdetail' = null;
/if;

if: ($mysql_hostid > 0);
	var: 'mysql_databasemap' = (_admin_listdatabases: $mysql_hostid);
	loop: -loopfrom=$mysql_databasemap->size, -loopto=1, -loopincrement=(-1);
		if: $mysql_databasemap->(get: loop_count)->second->(find: 'status') != 'enabled';
			$mysql_databasemap->(remove: loop_count);
		/if;
	/loop;
	var: 'temp' = (_admin_defaultdatabase: $mysql_databaseid, $mysql_databasemap);
	if: ($temp != null);
		var: 'mysql_databaseid' = $temp->first;
		var: 'mysql_databasedetail' = $temp->second;
		var: 'mysql_databasename' = $mysql_databasedetail->(find: 'name');
		var: 'mysql_databasealias' = $mysql_databasedetail->(find: 'alias');
	else;
		var: 'mysql_databaseid' = 0;
		var: 'mysql_databasedetail' = null;
	/if;
else;
	var: 'mysql_databaseid' = 0;
	var: 'mysql_databasedetail' = null;
/if;

if: ($mysql_databaseid > 0);
	var: 'mysql_tablemap' = (_admin_listtables: $mysql_databaseid);
	var: 'temp' = (_admin_defaulttable: $mysql_tableid, $mysql_tablemap);
	if: ($temp != null);
		var: 'mysql_tableid' = $temp->first;
		var: 'mysql_tabledetail' = $temp->second;
		var: 'mysql_tablename' = $mysql_tabledetail->(find: 'name');
		var: 'mysql_tablealias' = $mysql_tabledetail->(find: 'alias');
	else;
		var: 'mysql_tableid' = 0;
		var: 'mysql_tabledetail' = null;
	/if;
else;
	var: 'mysql_tableid' = 0;
	var: 'mysql_tabledetail' = null;
/if;


//
// Correct name of 'site' database
//

if: ($mysql_connectorid == 1) && ($mysql_databasename == 'site');
	var: 'mysql_databasename' = 'lasso_site_1';
/if;

//
// Get Table Status
//

var: 'mysql_tabletimes' = (map);
inline: -database=$mysql_databasealias, -sql='SHOW TABLE STATUS FROM `' + $mysql_databasename + '`', -maxrecords='all';
	records;
		$mysql_tabletimes->(insert: (field: 'name') = (field: 'check_time'));
	/records;
/inline;



//
// Batch Processing
//

if: ($mysql_action >> 'Perform') || ($mysql_action >> 'Schedule');

	var: 'table_list' = '';
	var: 'lock_list' = '';

	loop: $mysql_checked->size;
		var: 'table_temp' = $mysql_tablemap->(find: $mysql_checked->(get: loop_count));
		if: $table_temp != (array);
			var: 'table_name' = $table_temp->(get:1)->second->(find: 'name');
			$table_list += '`' + $table_name + '`,';
			$lock_list += '`' + $table_name + '` READ,';
		/if;
	/loop;
	$table_list->(removetrailing: ',');
	$lock_list->(removetrailing: ',');

	if: $table_list == '';

		var: 'error' = 'Please select one or more tables on which to perform the operation.';

	else: ($mysql_action >> 'Schedule');

		var: 'mysql_scheduleaction' = $mysql_batchaction + ':' + $database_name + ':' + $table_list;

		redirect_url: $admin_link + '&tab2=event&tab3=addevent&event_action=admin';
		
		abort;

	else: ($mysql_action >> 'Perform');

		if: $mysql_batchaction >> 'flush';

			var: 'header' = 'Flush Table Results';
			var: 'sql'='FLUSH TABLE ' + $table_list;

		else: $mysql_batchaction >> 'analyze';

			var: 'header' = 'Analyze Table Results';
			var: 'sql'='ANALYZE TABLE ' + $table_list;

		else: $mysql_batchaction >> 'optimize';

			var: 'header' = 'Optimize Table Results';
			var: 'sql'='OPTIMIZE TABLE ' + $table_list;

		else: $mysql_batchaction >> 'check quick';

			var: 'header' = 'Check Tables (Quick)';
			var: 'sql'='CHECK TABLE ' + $table_list + ' QUICK';

		else: $mysql_batchaction >> 'check medium';

			var: 'header' = 'Check Tables';
			var: 'sql'='CHECK TABLE ' + $table_list + ' MEDIUM';

		else: $mysql_batchaction >> 'check extended';

			var: 'header' = 'Check Tables (Extended)';
			var: 'sql'='CHECK TABLE ' + $table_list + ' EXTENDED';

		else: $mysql_batchaction >> 'repair quick';

			var: 'header' = 'Repair Tables (Quick)';
			var: 'sql'='REPAIR TABLE ' + $table_list + ' QUICK';

		else: $mysql_batchaction >> 'repair medium';

			var: 'header' = 'Repair Tables';
			var: 'sql'='REPAIR TABLE ' + $table_list;

		else: $mysql_batchaction >> 'repair extended';

			var: 'header' = 'Repair Tables (Extended)';
			var: 'sql'='REPAIR TABLE ' + $table_list + ' EXTENDED';

		else: $mysql_batchaction >> 'backup';

			var: 'header' = 'Backup Tables';
			var: 'export_folder' = (_admin_servicepath) + 'Admin/Backup/';

			if: !(file_exists: $export_folder);
				file_create: $export_folder;
			/if;

			if: !(file_exists: $export_folder);
				var: 'error'='Export folder not found.  Please create a folder named "Backup" in the Lasso Professional 7/Admin folder';
			/if;

			if: (var: 'error') == '';
				var: 'database_folder' = $export_folder + $database_name + '/';
				if: !(file_exists: $database_folder);
					file_create: $database_folder;
				/if;

				if: !(file_exists: $database_folder);
					var: 'error' = 'Could not create export folder.  Please check that lasso can access the "Backup" folder in the Lasso Professional 7/Admin folder';
				/if;
			/if;

			if: (var: 'error') == '';
				var: 'datetime_folder' = $database_folder + (date_format: (date_getcurrentdate), -dateformat='%Y%m%d_%H%M%S') + '/';
				if: !(file_exists: $datetime_folder);
					file_create: $datetime_folder;
				/if;

				if: !(file_exists: $datetime_folder);
					var: 'error' = 'Could not create export folder.  Please check that lasso can access the "Backup" folder in the Lasso Professional 7/Admin folder';
				/if;

			/if;

			if: (var: 'error') == '';

				var: 'temp_folder' = $datetime_folder;
				$temp_folder->(removetrailing:'/');

				if: (lasso_version: -lassoplatform) >> 'Win32';
					var: 'temp_folder' = (string_replace: -find='/', -replace='\\\\', $temp_folder) + '\\\\';
				else;
					var: 'temp_folder' = (string_replace: -find='///', -replace='/', $temp_folder);
				/if;

				var: 'sql'='BACKUP TABLE ' + $table_list + ' TO "' + $temp_folder + '"';

			/if;
		/if;
	/if;
/if;

//
// Process Navigation
//

if: $mysql_navigation >> 'Prev';
	$mysql_table_skip -= 10;
else: $mysql_navigation >> 'Next';
	$mysql_table_skip += 10;
else: $mysql_navigation >> 'First';
	$mysql_table_skip = 1;
else: $mysql_navigation >> 'Last';
	$mysql_table_skip = $mysql_tablemap->size - (($mysql_tablemap->size - 1) % 10);
else: $mysql_navigation >> 'Jump';
	$mysql_table_skip = integer: $mysql_jump;
/if;

var: 'found_count' = $mysql_tablemap->size;
var: 'mysql_table_skip' = integer: (math_max: 1, (math_min: $mysql_table_skip, $found_count));
var: 'shown_first' = $mysql_table_skip;
var: 'shown_last' = integer: (math_min: $found_count, $mysql_table_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

if: ($database_name != $mysql_databasename);
	var: 'mysql_checkaction' = 'All';
/if;

if: $mysql_checkaction >> 'None';
	var: 'mysql_checked' = (array);
else: $mysql_checkaction >> 'All';
	var: 'mysql_checked' = (array);
	loop: $mysql_tablemap->size;
		$mysql_checked->(insert: $mysql_tablemap->(get: loop_count)->first);
	/loop;
/if;

var: 'checked_count' = $mysql_checked->size;

?>
