<?LassoScript

	// -----------
	// global vars
		
	var:'lasso_classic'=null;
	var:'error_reporting'=null;
	var:'recursion_limit'=null;
	var:'execution_timelimit'=null;
	var:'execution_override'='Y';
	var:'default_page_encoding'=null;
	var:'settings_action' = (action_param:'action');
	

	// get the data
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='lasso_classic_enabled';
		if: (found_count) > 0;
			var: 'lasso_classic' = (field: 'data');
		/if;
	/inline;
	
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='error_reporting';
		if: (found_count) > 0;
			var: 'error_reporting' = (field: 'data');
		/if;
	/inline;
	
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='recursion_limit';
		if: (found_count) > 0;
			var: 'recursion_limit' = (field: 'data');
		/if;
	/inline;
	
	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='execution_timelimit';
		if: (found_count) > 0;
			var: 'execution_timelimit' = (field: 'data');
		/if;
	/inline;

	inline: -search,
			-database='lasso_internal', 
			-table='security_tags',
			-keyfield='name',
			-keyvalue='lasso_executiontimelimit';
		if: (found_count) > 0;
			var: 'execution_override' = (field: 'enabled');
		else;
			var: 'execution_override' = 'N';
		/if;
	/inline;
	
	if: $execution_override != 'N';
		var: 'execution_override' = 'Y';
	/if;

	inline: -search,
			-database='lasso_internal', 
			-table='global_prefs',
			-keyfield='store_key',
			-keyvalue='default_page_encoding';
		if: (found_count) > 0;
			var: 'default_page_encoding' = (field: 'data');
		/if;
	/inline;


	
	// set sefaults
	if: $lasso_classic === null;
		inline: -add,
				-database='lasso_internal', 
				-table='global_prefs',
				'store_key'='lasso_classic_enabled',
				'data'='N';
		/inline;
		var: 'lasso_classic' = 'N';
	/if;

	if: $error_reporting === null;
		inline: -add,
				-database='lasso_internal', 
				-table='global_prefs',
				'store_key'='error_reporting',
				'data'='minimal';
		/inline;
		var: 'error_reporting' = 'minimal';
	/if;

	if: $recursion_limit === null;
		inline: -add,
				-database='lasso_internal', 
				-table='global_prefs',
				'store_key'='recursion_limit',
				'data'=50;
		/inline;
		var: 'recursion_limit' = 50;
	/if;

	if: $execution_timelimit === null;
		inline: -add,
				-database='lasso_internal', 
				-table='global_prefs',
				'store_key'='execution_timelimit',
				'data'=600;
		/inline;
		var: 'execution_timelimit' = 600;
	/if;

	if: $default_page_encoding === null;
		inline: -add,
				-database='lasso_internal', 
				-table='global_prefs',
				'store_key'='default_page_encoding',
				'data'='UTF-8';
		/inline;
		var: 'default_page_encoding' = 'utf-8';
	/if;

	// dispatch
	if: $settings_action >> 'Update';
	
		var: 'lasso_classic' = (action_param: 'lasso_classic');
		var: 'error_reporting' = (action_param: 'error_reporting');
		var: 'recursion_limit' = (integer: action_param: 'recursion_limit');
		var: 'recursion_enable' = (action_param: 'recursion_enable');
		var: 'execution_timelimit' = (integer: action_param: 'execution_timelimit');
		var: 'execution_enable' = (action_param: 'execution_enable');
		var: 'execution_override' = (action_param: 'execution_override');
		var: 'default_page_encoding' = (action_param: 'default_page_encoding');
		
		if: $lasso_classic >> 'Y';
			var: 'lasso_classic' = 'Y';
		else;
			var: 'lasso_classic' = 'N';
		/if;
	
		if: $recursion_enable >> 'N';
			var: 'recursion_limit' = 0;
		/if;
	
		if: $execution_enable >> 'N';
			var: 'execution_timelimit' = 0;
		else: $execution_timelimit < 60;
			var: 'execution_timelimit' = 60;
		/if;
	
		if: $execution_override != 'N';
			var: 'execution_override' = 'Y';
		/if;

		if: $default_page_encoding == '...';
			var: 'default_page_encoding' = (action_param: 'page_encoding_other');
			$default_page_encoding->trim;
		/if;
		
		if: $default_page_encoding == '';
			var: 'default_page_encoding' = 'UTF-8';
		/if;

	inline: -update, 
				-database='lasso_internal', 
				-table='global_prefs',
				-keyfield='store_key', 
				-keyvalue='lasso_classic_enabled',
				'data' = (var:'lasso_classic');
		/inline;
		
		protect;
			lasso_errorreporting: (var: 'error_reporting'), -global;
		/protect;

		inline: -update, 
				-database='lasso_internal', 
				-table='global_prefs',
				-keyfield='store_key', 
				-keyvalue='error_reporting',
				'data' = (var:'error_reporting');
		/inline;
		
		protect;
			_recursion_limit: (var: 'recursion_limit');
		/protect;
		
		inline: -update, 
				-database='lasso_internal', 
				-table='global_prefs',
				-keyfield='store_key', 
				-keyvalue='recursion_limit',
				'data' = (var:'recursion_limit');
		/inline;

		protect;
			_execution_timelimit: (var: 'execution_timelimit');
		/protect;

		inline: -update, 
				-database='lasso_internal', 
				-table='global_prefs',
				-keyfield='store_key', 
				-keyvalue='execution_timelimit',
				'data' = (var:'execution_timelimit');
		/inline;

		inline: -update, 
				-database='lasso_internal', 
				-table='security_tags',
				-keyfield='name', 
				-keyvalue='lasso_executiontimelimit',
				'enabled' = (var:'execution_override');
		/inline;

		inline: -update, 
				-database='lasso_internal', 
				-table='global_prefs',
				-keyfield='store_key', 
				-keyvalue='default_page_encoding',
				'data' = $default_page_encoding;
			global: '__encoding__' = $default_page_encoding;
		/inline;

		_security_flushcaches;
	/if;

?>
