<?LassoScript

var: 'admin_refresh' = true;

_admin_addvar: 'error_status', -session='_admin', -default='all', -override=(action_param: 'error_status');
_admin_addvar: 'error_action', -default='None', -override=(action_param: 'error_action');
_admin_addvar: 'error_search', -default='', -override=(action_param: 'error_search');
_admin_addvar: 'error_date', -default='', -override=(action_param: 'error_date');
_admin_addvar: 'error_query', -session='_admin', -default=null;

_admin_addvar: 'error_skip', -default=0, -session='_admin', -override=(action_param: 'error_skip');
_admin_addvar: 'error_max', -default=10;
_admin_addvar: 'error_navigation', -override=(action_param: 'error_navigation');
_admin_addvar: 'error_jump', -override=(action_param: 'error_jump');
_admin_addvar: 'error_found', -default=0, -session='_admin';

_admin_addvar: 'error_sortfield', -default='id', -session='_admin', -override=(action_param: 'error_sortfield');
_admin_addvar: 'error_sortorder', -default='descending', -session='_admin', -override=(action_param: 'error_sortorder');

_admin_addvar: 'error_oldstatus', -override=(action_param: 'error_oldstatus');
if: ($error_oldstatus == '') || ($error_oldstatus != $error_status);
	var: 'error_skip' = 0;
/if;

var: 'error_skip' = (integer: $error_skip);
var: 'error_max' = (integer: $error_max);
var: 'error_found' = (integer: $error_found);

if: ($error_navigation >> 'Next');
	$error_skip = (integer: ($error_skip + $error_max));
else: ($error_navigation >> 'Prev');
	$error_skip = (integer: (math_max: $error_skip - $error_max, 0));
else: ($error_navigation >> 'Last');
	$error_skip = $error_found - $error_max;
else: ($error_navigation >> 'First') || ($error_navigation >> 'Sort');
	$error_skip = 0;
else: ($error_navigation >> 'Jump') || ((action_param: 'error_navigation_skip') != '');
	$error_skip = (math_max: (integer: (action_param: 'error_navigation_skip')) - 1, 0);
/if;

if: ($error_skip > 0) && ($error_found > 0);
	$error_skip = (math_max: (math_min: $error_found - 1, $error_skip), 0);
/if;


var: 'error_inline' = (array);

$error_inline->(insert: -database='lasso_internal');
$error_inline->(insert: -table='_errors');

$error_inline->(insert: -maxrecords=$error_max);
$error_inline->(insert: -skiprecords=$error_skip);

$error_inline->(insert: -sortfield=$error_sortfield);
$error_inline->(insert: -sortorder=$error_sortorder);

if: $error_search != '';

	$error_inline->(insert: -op='cn');
	$error_inline->(insert: 'message'=$error_search);

/if;

if: $error_date != '';

	var: 'temp' = (string: (date_format: $error_date, -dateformat='%Y%m%d%H%M%S'));
	if: $temp != '';
		$temp->(removetrailing: '00');
		$error_inline->(insert: 'date_time'=$temp);
		$error_inline->(insert: -op='cn');
	else;
		$error_inline->(insert: -op='cn');
		$error_inline->(insert: 'date_time'=$error_date);
	/if;

/if;

if: $error_status >> 'all';

	$error_inline->(insert: -findall='');

else: $error_status >> 'critical';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=0);

else: $error_status >> 'warning';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=1);

else: $error_status >> 'detail';

	$error_inline->(insert: -search='');
	$error_inline->(insert: -op='eq');
	$error_inline->(insert: 'code'=2);

else: $error_status >> 'query';

	$error_inline->(merge: $error_query);

/if;

if: $error_action >> 'Delete Shown';

	var: 'id' = (array);
	inline: $error_inline, -maxrecords='all';
		records;
			$id->(insert: (field: 'id'));
		/records;
	/inline;

	if: $id->size > 0;
		inline: -database='lasso_internal', -sql='DELETE FROM _errors WHERE id IN (' + $id->(join: ',') + ')';
		/inline;
	/if;

else: $error_action >> 'Delete All';

	var: 'error_found' = 0;
	var: 'error_skip' = 0;
	
	inline: -database='lasso_internal', -sql='DELETE FROM _errors';
	/inline;

/if;

?>
