<?LassoScript
// This file sets up the environment in which the page will run.

// -----------
// sql queries

var:'kGlobalPrefs' = 'select store_key, data, date_format(modified, \'%m/%d/%Y %T\') as modified from lasso_internal.global_prefs
where store_key in (\'lasso_apps_enabled\')';

// -----------
// global vars

var:'err'= 0, 'err_msg'='';
var:'db' = 'lasso_internal';

var:'settings_map'=map;
var:'moddates_map'=map;
var:'settings_action' = action_param:'action';
var:'lassoapp_name' = action_param:'lassoapp_name';

// -----------
// main

if: action_param:'dialog_action' != null;
	$settings_action = action_param:'dialog_action';
/if;

// get the data
inline: -database=$db, -sql=$kGlobalPrefs;
	$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	if: !$err && found_count;
		records;
			if:(field:'store_key') == 'lasso_apps_enabled';
				$moddates_map->insert:'L'=(field:'modified');
				$settings_map->insert:(field:'store_key')=(field:'data');
			/if;
		/records;
	/if;
/inline;

if: $settings_map->(find:'lasso_apps_enabled')->type == 'null';
	inline: -add, -database=$db, -table='global_prefs',
			'store_key'='lasso_apps_enabled', 'data' = 'Y'; // enabled
	/inline;
	$settings_map->insert:'lasso_apps_enabled' = 'Y';
/if;

// dispatch
if: $settings_action >> 'Update';

	inline: -update, -database=$db, -table='global_prefs',
			-keyfield='store_key', -keyvalue='lasso_apps_enabled',
			'data' = action_param:'lassoapps_enabled';
		$err = error_currenterror:-errorcode; $err_msg = error_currenterror;
	/inline;
	$settings_map->insert:'lasso_apps_enabled' = action_param:'lassoapps_enabled';

	_security_flushcaches;

else: ($settings_action >> 'Dump All');

	lassoapp_dump;

	var: 'lassoapp_result'='The LassoApp cache has been cleared of all LassoApps.';

	redirect_url:'/Lasso/default.htm';

else: ($settings_action >> 'Dump') && $lassoapp_name != '';

	lassoapp_dump: $lassoapp_name;

	var: 'lassoapp_result'='The specified LassoApp has been cleared from the LassoApp cache.';

	if: ($lassoapp_name >> 'admin.lassoapp');
		redirect_url:'/Lasso/default.htm';
	/if;

else: ($settings_action >> 'Dump');

	var: 'lassoapp_result'='Please enter the name of a LassoApp.';
/if;

?>
