<?LassoScript

//
// Variables
//
_admin_addvar: 'mysql_userid', -default='', -override=(action_param: 'mysql_userid');
_admin_addvar: 'mysql_user', -override=(action_param: 'mysql_user');
_admin_addvar: 'mysql_host', -override=(action_param: 'mysql_host');
_admin_addvar: 'mysql_password', -override=(action_param: 'mysql_password');

_admin_addvar: 'mysql_actionuser', -override=(action_param: 'mysql_actionuser');
_admin_addvar: 'mysql_actionhost', -override=(action_param: 'mysql_actionhost');

var: 'mysql_perms' = '';
loop: (action_param: 'mysql_perms', -count); $mysql_perms += (action_param: 'mysql_perms', loop_count) + ','; /loop;
$mysql_perms->(removetrailing: ',');

_admin_addvar: 'mysql_action', -default='None', -override=(action_param: 'mysql_action', (action_param: 'mysql_action', -count));
_admin_addvar: 'mysql_perm_skip', -default=1, -session='_admin', -override=(action_param: 'mysql_perm_skip');
_admin_addvar: 'mysql_navigation', -override=(action_param: 'mysql_navigation');
_admin_addvar: 'mysql_jump', -override=(action_param: 'mysql_jump');

//
// Process Action
//

if: $mysql_action >> 'Create User...';
	var: 'mysql_userid' = 'new';
	var: 'user' = 'New_Username';
	var: 'host' = 'Host_Name';
	var: 'password' = '';
	var: 'mysql_user' = (map:
		'user'=$user,
		'host'=$host,
		'password'=$password,
		'select_priv'='Y',
		'insert_priv'='Y',
		'update_priv'='Y',
		'delete_priv'='Y',
		'create_priv'='N',
		'drop_priv'='N',
		'reload_priv'='Y',
        'shutdown_priv'='N',
		'process_priv'='N',
		'file_priv'='N',
		'grant_priv'='N',
		'references_priv'='N',
		'index_priv'='N',
		'alter_priv'='N'
	);

else:  $mysql_action >> 'Create User';

	var: 'error' = '';

	if: ($mysql_user == 'lasso') && ($mysql_host == 'localhost');
		var: 'error' = 'The "lasso" user is required by Lasso and cannot be overwritten.';
	else: ($mysql_user == 'shutdown') && ($mysql_host == 'localhost');
		var: 'error' = 'The "shutdown" user is required by Lasso and cannot be overwritten.';
	else: ($mysql_user == 'root') && ($mysql_host == 'localhost');
		var: 'error' = 'The "root" user cannot be deleted or overwritten.';
	else: ($mysql_user == '') && ($mysql_host == 'localhost');
		var: 'error' = 'The default user cannot be deleted or overwritten.';
	/if;

	if: $error == '';

		var: 'temp_perms' = $mysql_perms;
		var: 'temp_grant' = false;

		if: $temp_perms == '';
			var: 'temp_perms' = 'USAGE';
		else: $temp_perms >> 'GRANT';
			$temp_perms -= 'GRANT,';
			$temp_perms -= ',GRANT';
			$temp_perms -= 'GRANT';
			var: 'temp_grant' = true;
		/if;

		var: 'sql' = 'GRANT ' + $temp_perms + ' ON *.* TO \'' + $mysql_user + '\'@\'' + $mysql_host + '\'';
		if: $mysql_password != '';
			$sql += ' IDENTIFIED BY \'' + $mysql_password + '\'';
		/if;
		if: $temp_grant;
			$sql += ' WITH GRANT OPTION';
		/if;

		inline: -database='lasso_internal', -sql=$sql;
			if: (error_currenterror) != (error_noerror);
				var: 'error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
			else;
				var: 'mysql_action' = 'detail';
			/if;
		/inline;
		
	/if;

	if: $error != '';
		var: 'mysql_userid' = 'new';

		var: 'mysql_user' = (map:
			'user'=$mysql_user,
			'host'=$mysql_host,
			'password'=$mysql_password);

		if: $mysql_perms >> 'SELECT';
			$mysql_user->(insert: 'select_priv'='Y');
		else;
			$mysql_user->(insert: 'select_priv'='N');
		/if;
		if: $mysql_perms >> 'INSERT';
			$mysql_user->(insert: 'insert_priv'='Y');
		else;
			$mysql_user->(insert: 'insert_priv'='N');
		/if;
		if: $mysql_perms >> 'UPDATE';
			$mysql_user->(insert: 'update_priv'='Y');
		else;
			$mysql_user->(insert: 'update_priv'='N');
		/if;
		if: $mysql_perms >> 'DELETE';
			$mysql_user->(insert: 'delete_priv'='Y');
		else;
			$mysql_user->(insert: 'delete_priv'='N');
		/if;
		if: $mysql_perms >> 'CREATE';
			$mysql_user->(insert: 'create_priv'='Y');
		else;
			$mysql_user->(insert: 'create_priv'='N');
		/if;
		if: $mysql_perms >> 'DROP';
			$mysql_user->(insert: 'drop_priv'='Y');
		else;
			$mysql_user->(insert: 'drop_priv'='N');
		/if;
		if: $mysql_perms >> 'RELOAD';
			$mysql_user->(insert: 'reload_priv'='Y');
		else;
			$mysql_user->(insert: 'reload_priv'='N');
		/if;
		if: $mysql_perms >> 'SHUTDOWN';
			$mysql_user->(insert: 'shutdown_priv'='Y');
		else;
			$mysql_user->(insert: 'shutdown_priv'='N');
		/if;
		if: $mysql_perms >> 'PROCESS';
			$mysql_user->(insert: 'process_priv'='Y');
		else;
			$mysql_user->(insert: 'process_priv'='N');
		/if;
		if: $mysql_perms >> 'FILE';
			$mysql_user->(insert: 'file_priv'='Y');
		else;
			$mysql_user->(insert: 'file_priv'='N');
		/if;
		if: $mysql_perms >> 'GRANT';
			$mysql_user->(insert: 'grant_priv'='Y');
		else;
			$mysql_user->(insert: 'grant_priv'='N');
		/if;
		if: $mysql_perms >> 'REFERENCES';
			$mysql_user->(insert: 'references_priv'='Y');
		else;
			$mysql_user->(insert: 'references_priv'='N');
		/if;
		if: $mysql_perms >> 'INDEX';
			$mysql_user->(insert: 'index_priv'='Y');
		else;
			$mysql_user->(insert: 'index_priv'='N');
		/if;
		if: $mysql_perms >> 'ALTER';
			$mysql_user->(insert: 'alter_priv'='Y');
		else;
			$mysql_user->(insert: 'alter_priv'='N');
		/if;
	/if;

else: ($mysql_action >> 'Update') || ($mysql_action >> 'Delete');

	var: 'error' = '';

	if: ($mysql_user == 'lasso') && ($mysql_host == 'localhost');
		var: 'error' = 'The "lasso" user is required by Lasso and cannot be modified or deleted.';
	else: ($mysql_user == 'shutdown') && ($mysql_host == 'localhost');
		var: 'error' = 'The "shutdown" user is required by Lasso and cannot be modified or deleted.';
	/if;
	
	if: $error == '';
		var: 'sql' = 'DELETE FROM mysql.user WHERE user=\'' + $mysql_actionuser + '\' AND host=\'' + $mysql_actionhost + '\'';

		inline: -database='lasso_internal', -sql=$sql;
			if: (error_currenterror) != (error_noerror);
				var: 'error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
			/if;
		/inline;
		
	/if;

	if: ($mysql_action >> 'Delete');
		var: 'mysql_userid' = '';
		var: 'mysql_action' = 'None';
	/if;

	if: ($mysql_action >> 'Update') && ($error == '');

		var: 'temp_perms' = $mysql_perms;
		var: 'temp_grant' = false;

		if: $temp_perms == '';
			var: 'temp_perms' = 'USAGE';
		else: $temp_perms >> 'GRANT';
			$temp_perms -= 'GRANT,';
			$temp_perms -= ',GRANT';
			$temp_perms -= 'GRANT';
			var: 'temp_grant' = true;
		/if;

		var: 'sql' = 'GRANT ' + $temp_perms + ' ON *.* TO \'' + $mysql_user + '\'@\'' + $mysql_host + '\'';
		if: $mysql_password != '';
			$sql += ' IDENTIFIED BY \'' + $mysql_password + '\'';
		/if;
		if: $temp_grant;
			$sql += ' WITH GRANT OPTION';
		/if;

		inline: -database='lasso_internal', -sql=$sql;
			if: (error_currenterror) != (error_noerror);
				var: 'error' = (error_currenterror + ' (' + (error_currenterror: -errorcode) + ')');
			else;
				var: 'mysql_action' = 'detail';
			/if;
		/inline;
	/if;

	inline: -database='lasso_internal', -sql='FLUSH PRIVILEGES'; /inline;

else: $mysql_action >> 'flush';

	inline: -database='lasso_internal', -sql='FLUSH PRIVILEGES'; /inline;

/if;


//
// User Map
//

var: 'mysql_usermap' = (array);

inline: -database='lasso_internal', -sql='SELECT * FROM mysql.user ORDER BY user, host', -maxrecords='all';
	records;
		var: 'temp' = (map);
		var: 'id' = (field: 'user') + '@' + (field: 'host');
		loop: (field_name: -count);
			$temp->(insert: (field_name: loop_count) = (field: (field_name: loop_count)));
		/loop;
		$mysql_usermap->(insert: $id = $temp);
	/records;
/inline;

if: ($mysql_userid != '') && ($mysql_userid != 'new');
	var: 'temp' = $mysql_usermap->(find: $mysql_userid);
	if: $temp->size > 0;
		var: 'mysql_user' = $mysql_usermap->(find: $mysql_userid)->(get:1)->second;
		var: 'user' = $mysql_user->(find: 'user');
		var: 'host' = $mysql_user->(find: 'host');
		var: 'password' = $mysql_user->(find: 'password');
	/if;
/if;


//
// Process Navigation
//

if: $mysql_navigation >> 'Prev';
	$mysql_perm_skip -= 10;
else: $mysql_navigation >> 'Next';
	$mysql_perm_skip += 10;
else: $mysql_navigation >> 'First';
	$mysql_perm_skip = 1;
else: $mysql_navigation >> 'Last';
	$mysql_perm_skip = $mysql_usermap->size - (($mysql_usermap->size - 1) % 10);
else: $mysql_navigation >> 'Jump';
	$mysql_perm_skip = integer: $mysql_jump;
/if;

var: 'found_count' = $mysql_usermap->size;
var: 'mysql_perm_skip' = integer: (math_max: 1, (math_min: $mysql_perm_skip, $found_count));
var: 'shown_first' = $mysql_perm_skip;
var: 'shown_last' = integer: (math_min: $found_count, $mysql_perm_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

?>
