<?LassoScript

//
// Variables
//

_admin_addvar: 'mysql_databaseid', -session='_admin', -override=(action_param: 'mysql_databaseid');
_admin_addvar: 'mysql_backupid', -session='_admin', -override=(action_param: 'mysql_backupid');

_admin_addvar: 'mysql_backupold', -override=(action_param: 'mysql_backupold');
if: ($mysql_backupold == '') && ($mysql_backupold != $mysql_backupid);
	var: 'mysql_checkaction' = 'all';
/if;

_admin_addvar: 'mysql_action', -default='None', -override=(action_param: 'mysql_action', (action_param: 'mysql_action', -count));
_admin_addvar: 'mysql_restoreaction', -session='_admin', -default='new', -override=(action_param: 'mysql_restoreaction');
_admin_addvar: 'mysql_batcholdname', -override=(action_param: 'mysql_batcholdname');
_admin_addvar: 'mysql_batcholdbackup', -default='Yes', -override=(action_param: 'mysql_batcholdbackup');
_admin_addvar: 'mysql_batchnewname', -override=(action_param: 'mysql_batchnewname');

_admin_addvar: 'mysql_restore_skip', -default=1, -session='_admin', -override=(action_param: 'mysql_restore_skip');
_admin_addvar: 'mysql_navigation', -override=(action_param: 'mysql_navigation');
_admin_addvar: 'mysql_jump', -override=(action_param: 'mysql_jump');

_admin_addvar: 'mysql_checked', -session='_admin', -override=(array);
_admin_addvar: 'mysql_checkaction', -override=(action_param: 'mysql_checkaction');

var: 'mysql_checked' = (array);
loop: (action_param: 'mysql_checked', -count); $mysql_checked->(insert: (action_param: 'mysql_checked', loop_count)); /loop;

//
// Build Menus
//

var: 'mysql_connectormap' = (array);
var: 'mysql_hostmap' = (array);
var: 'mysql_databasemap' = (array);
var: 'mysql_tablemap' = (array);

if: ($mysql_action >> 'Refresh') && ($mysql_connectorid != 0);
	_admin_refreshsecurity;
/if;

var: 'mysql_connectormap' = (_admin_listconnectors);
var: 'temp' = $mysql_connectormap->(get:1);
if: ($temp != null);
	var: 'mysql_connectorid' = $temp->first;
	var: 'mysql_connectordetail' = $temp->second;
	var: 'mysql_connectoralias' = $mysql_connectordetail->(find: 'alias');
else;
	var: 'mysql_connectorid' = 0;
	var: 'mysql_connectordetail' = null;
/if;

if: ($mysql_action >> 'Refresh') && ($mysql_connectorid != 0);
	_admin_refreshconnector: $mysql_connectorid;
/if;

if: ($mysql_connectorid > 0);
	var: 'mysql_hostmap' = (_admin_listhosts: $mysql_connectorid);
	var: 'temp' = (_admin_defaulthost: $mysql_hostid, $mysql_hostmap);
	if: ($temp != null);
		var: 'mysql_hostid' = $temp->first;
		var: 'mysql_hostdetail' = $temp->second;
	else;
		var: 'mysql_hostid' = 0;
		var: 'mysql_hostdetail' = null;
	/if;
else;
	var: 'mysql_hostid' = 0;
	var: 'mysql_hostdetail' = null;
/if;

var: 'mysql_tempmap' = (_admin_listdatabases: $mysql_hostid);
var: 'mysql_aliasmap' = (map);
var: 'mysql_labelmap' = (map);

iterate: $mysql_tempmap, (var: 'temp_alias');
	$mysql_aliasmap->(insert: $temp_alias->second->(find: 'name') = $temp_alias->second->(find: 'alias'));
	$mysql_labelmap->(insert: $temp_alias->second->(find: 'name') = $temp_alias->second->(find: 'label'));
/iterate;

	var: 'export_folder' = (_admin_servicepath) + 'Admin/Backup/';

	if: !(file_exists: $export_folder);
		file_create: $export_folder;
	/if;
	if: !(file_exists: $export_folder);
		var: 'error'='Export folder not found.  Please create a folder named "Backup" in the Lasso Professional 7/Admin folder';
	/if;

	var: 'backup_list' = (file_listdirectory: $export_folder);
	var: 'mysql_databasemap' = (array);

	$backup_list->(sort: false);

	iterate: $backup_list, (var: 'temp_name');
		var: 'temp_path' = $export_folder + $temp_name;
		if: (file_isdirectory: $temp_path);
			$temp_name->(removetrailing: '/');
			$mysql_databasemap->(insert: $temp_name);
		/if;
	/iterate;

	if: ($mysql_databasemap->size > 0) && ($mysql_databasemap->(find: $mysql_databaseid) == (array));
		var: 'mysql_databaseid' = $mysql_databasemap->(get:1);
	/if;

	if: $mysql_databaseid == 'site';
		var: 'mysql_databaseid' = 'lasso_site_1';
	/if;

	var: 'database_folder' = $export_folder + $mysql_databaseid + '/';
	if: !(file_exists: $database_folder);

		var: 'mysql_backupmap' = (array);
		var: 'backup_id' = '';

	else;

		var: 'mysql_backupmap' = (array);

		var: 'backup_list' = (file_listdirectory: $database_folder);

		$backup_list->(sort: false);

		iterate: $backup_list, (var: 'temp_name');
			var: 'temp'=(map);
			var: 'temp_path' = $database_folder + $temp_name;
			$temp->(insert: 'path' = $temp_path);
			if: (file_isdirectory: $temp_path);

				var: 'temp_listing' = (file_listdirectory: $temp_path);
				var: 'temp_tables' = (array);
				iterate: $temp_listing, (var: 'temp_listitem');
					if: $temp_listitem >> '.frm';
						$temp_listitem -= '.frm';
						$temp_tables->(insert: $temp_listitem);
					/if;
				/iterate;
				$temp->(insert: 'tables' = $temp_tables);

				$temp_name->(removetrailing: '/');
				$temp->(insert: 'id' = $temp_name);

				var: 'datetime' = (string: (date: $temp_name, -dateformat='%Y%m%d_%H%M%S'));
				$temp->(insert: 'datetime' = $datetime);

				$mysql_backupmap->(insert: $temp_name = $temp);
			/if;
		/iterate;

	/if;

if: ($mysql_backupmap == null) || ($mysql_backupmap->size == 0);
	var: 'mysql_backupid' = '';
else: ($mysql_backupmap->(find: $mysql_backupid) == (array));
	var: 'mysql_backupid' = $mysql_backupmap->(get:1)->first;
/if;
var: 'temp' = $mysql_backupmap->(find: $mysql_backupid);
if: $temp->size > 0;
	var: 'mysql_backupdetail' = $temp->(get:1)->second;
else;
	var: 'mysql_backupdetail' = (map);
/if;



//
// Batch Processing
//

if: $mysql_action >> 'Perform';

	var: 'table_list' = (array);

	var: 'temp_list' = $mysql_backupdetail->(find: 'tables');

	iterate: $mysql_checked, (var: 'temp');
		if: $temp_list->(find: $temp) != (array);
			$table_list->(insert: $temp);
		/if;
	/iterate;

	if: $table_list == '';

		var: 'error' = 'Please select one or more tables on which to perform the operation.';

	else;

		var: 'name_exists' = false;

		var: 'mysql_connectormap' = (_admin_listconnectors);
		var: 'mysql_connectorid' = $mysql_connectormap->(get:1)->first;
		var: 'mysql_hostmap' = (_admin_listhosts: $mysql_connectorid);
		var: 'mysql_hostid' = $mysql_hostmap->(get:1)->first;
		var: 'temp_map' = (_admin_listdatabases: $mysql_hostid);

		if: ($mysql_restoreaction >> 'overwrite');
			var: 'temp_name' = $mysql_databaseid;
		else;
			iterate: $temp_map, (var: 'temp');
				if: $temp->second->(find: 'name') == $mysql_batchnewname;
					$name_exists = true;
				/if;
			/iterate;

			if: ($name_exists == true);
				var: 'error' = 'That database name already exists';
			else;
				var: 'temp_name' = $mysql_batchnewname;
			/if;
		/if;

		if: ((var: 'error') == '') && ($mysql_restoreaction >> 'new');

			inline: -database='lasso_internal', -sql='CREATE DATABASE ' + $temp_name;
				if: (error_currenterror) != (error_noerror);
					var: 'error' = (error_currenterror) + ' (' + (error_currenterror: -errorcode) + ')';
				/if;
			/inline;

			if: ((var: 'build_error') == '');

				_admin_refreshsecurity;
				_admin_refreshconnector: $mysql_connectorid;

				var: 'temp_databasemap' = (_admin_listdatabases: $mysql_hostid);
				var: 'temp_databaseid' = 0;

				iterate: $temp_databasemap, (var: 'temp');
					if: $temp->second->(find: 'name') == $temp_name;
						$temp_databaseid = $temp->first;
					/if;
				/iterate;

				if: $temp_databaseid != 0;
					_admin_updatedatabase: $temp_databaseid, 'enabled'='Y';
					_admin_refreshsecurity;
					_admin_refreshconnector: $mysql_connectorid;
				/if;

			/if;

		/if;


		if: ($mysql_restoreaction >> 'overwrite') && ($mysql_batcholdbackup >> 'yes');

			// Need to backup and delete old tables.

			if: (var: 'error') == '';
				var: 'datetime_folder' = $database_folder + (date_format: (date_getcurrentdate), -dateformat='%Y%m%d_%H%M%S') + '/';
				if: !(file_exists: $datetime_folder);
					file_create: $datetime_folder;
				/if;

				if: !(file_exists: $datetime_folder);
					var: 'error' = 'Could not create export folder.  Please check that lasso can access the "Backup" folder in the Lasso Professional 7/Admin folder';
				/if;

			/if;

			if: (var: 'error') == '';

				var: 'temp_folder' = $datetime_folder;
				$temp_folder->(removetrailing:'/');

				if: (lasso_version: -lassoplatform) >> 'Win32';
					var: 'temp_folder' = (string_replace: -find='/', -replace='\\\\', $temp_folder) + '\\\\';
				else;
					var: 'temp_folder' = (string_replace: -find='///', -replace='/', $temp_folder);
				/if;

				var: 'sql'='BACKUP TABLE `' + $table_list->(join: '`,`') + '` TO "' + $temp_folder + '"';
				inline: -database=(_admin_ifempty: $mysql_aliasmap->(find: $mysql_databaseid), $mysql_databaseid), -sql=$sql, -maxrecords='all'; /inline;

				var: 'sql'='DROP TABLE IF EXISTS `' + $table_list->(join: '`,`') + '`';
				inline: -database=(_admin_ifempty: $mysql_aliasmap->(find: $mysql_databaseid), $mysql_databaseid), -sql=$sql, -maxrecords='all'; /inline;

			/if;

		else: ($mysql_restoreaction >> 'overwrite') && !($mysql_batcholdbackup >> 'yes');
	
			if: (var: 'error') == '';

				var: 'sql'='DROP TABLE IF EXISTS `' + $table_list->(join: '`,`') + '`';
				inline: -database=(_admin_ifempty: $mysql_aliasmap->(find: $mysql_databaseid), $mysql_databaseid), -sql=$sql, -maxrecords='all'; /inline;

			/if;

		/if;

		if: (var: 'error') == '';

			var: 'temp_folder' = $mysql_backupdetail->(find: 'path');

			$temp_folder->(removetrailing:'/');

			if: (lasso_version: -lassoplatform) >> 'Win32';
				var: 'temp_folder' = (string_replace: -find='/', -replace='\\\\', $temp_folder) + '\\\\';
			else;
				var: 'temp_folder' = (string_replace: -find='///', -replace='/', $temp_folder);
			/if;

			var: 'sql' = 'RESTORE TABLE `' + $table_list->(join: '`,`') + '` FROM "' + $temp_folder + '"';
			// NOTE - The inline is performed in the detail of the page

		/if;

	/if;
/if;

if: (var: 'error') != '';
	var: 'mysql_action' = 'detail';
/if;

//
// Process Navigation
//

if: $mysql_navigation >> 'Prev';
	$mysql_restore_skip -= 10;
else: $mysql_navigation >> 'Next';
	$mysql_restore_skip += 10;
else: $mysql_navigation >> 'First';
	$mysql_restore_skip = 1;
else: $mysql_navigation >> 'Last';
	$mysql_restore_skip = $mysql_backupmap->size - (($mysql_backupmap->size - 1) % 10);
else: $mysql_navigation >> 'Jump';
	$mysql_restore_skip = integer: $mysql_jump;
/if;

var: 'found_count' = $mysql_backupmap->size;
var: 'mysql_restore_skip' = integer: (math_max: 1, (math_min: $mysql_restore_skip, $found_count));
var: 'shown_first' = $mysql_restore_skip;
var: 'shown_last' = integer: (math_min: $found_count, $mysql_restore_skip + 9);
var: 'shown_count' = ($shown_last - $shown_first + 1);

if: $mysql_checkaction >> 'None';
	var: 'mysql_checked' = (array);
else: $mysql_checkaction >> 'All';
	var: 'mysql_checked' = $mysql_backupdetail->(find: 'tables');
/if;

var: 'checked_count' = $mysql_checked->size;

?>
