<?LassoScript

	//
	// Custom Tags
	//
	include: (lassoapp_link: 'tags.lasso');

	//
	// Cache Control
	//
	_admin_nocache;
	
	//
	// Session
	//
	
	if: (action_param:'logout') == 'true';
		session_end: -name='_browse';
		redirect_url: 'logout.lasso';
	else;
		session_start: -name='_browse', -expires=1440, -usecookie;
		
		_admin_addvar: -session='_browse', -name='admin_datetime', -default=(string: date);
		_admin_addvar: -session='_browse', -name='admin_increment', -default='123453';
		_admin_addvar: -session='_browse', -name='admin_username', -override=(client_username), -default='';
		_admin_addvar: -session='_browse', -name='admin_ipaddress', -default=(string: _client_address_old);
		_admin_addvar: -session='_browse', -name='admin_usertype', -default='none';
	/if;
		
	var: 'admin_increment' = (integer: $admin_increment) + 3;
	
	//
	// Tab Arrays
	//
	
	var: 'admin_tab_disabled1' = (array);
	var: 'admin_tab_disabled2' = (array);
	var: 'admin_tab_disabled3' = (array);
	
		Variable: 'admin_tab_array1' = (Array:
			'browse'='Browse',
			'build'='Build',
		);
		Variable: 'admin_tab_array2' = (Array:
			'browse'=(Array:
				'html'='Database',
				'sql'='SQL',
			),
			'build'=(Array: 
				'databases'='Database',
			),
		);
		Variable: 'admin_tab_array3' = (Array:
			'browse:html'=(Array:
				'settings'='Settings',
				'search'='Search',
				'add'='Add',
				'list'='List',
				'detail'='Detail',
				'update'='Update',
				'import'='Import',
				'export'='Export',
			),
			'browse:sql'=(Array:
				'statement'='Statement',
			),
			'build:databases'=(Array:
				'databases'='Databases',
				'tables'='Tables',
				'fields'='Fields',
				'indices'='Indices',
			),
		);

	// Current Tab
	
	Variable: 'admin_tab1' = (action_param: 'tab1', (action_param: 'tab1', -count));
	Variable: 'admin_tab2' = (action_param: 'tab2', (action_param: 'tab2', -count));
	Variable: 'admin_tab3' = (action_param: 'tab3', (action_param: 'tab3', -count));

	// Default Tabs
	
//	If: ($admin_tab1 == '') || (_admin_array_find: $admin_tab_array1, $admin_tab1) == 'None';
//		variable: 'admin_tab1' = $admin_tab_array1->(get:1)->first;
//	/If;
	// Title
	
	var: 'admin_title' = 'Lasso ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1);
	var: 'temp' = (_admin_array_find: $admin_tab_array1, $admin_tab1);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

	var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array2, $admin_tab1), $admin_tab2);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;

	var: 'temp' = (_admin_array_find: (_admin_array_find: $admin_tab_array3, $admin_tab1 + ':' + $admin_tab2), $admin_tab3);
	if: ($temp != '') && ($temp != 'None');
		$admin_title += ' : ' + $temp;
	/if;
		/if;
	/if;

	//
	// LassoApp Links
	//

	var: 'admin_link_map' = (map:
		'browse/html/add/default.lasso' = (lassoapp_link: 'browse/html/add/default.lasso'),
		'browse/html/add/library.lasso' = (lassoapp_link: 'browse/html/add/library.lasso'),
		'browse/html/detail/default.lasso' = (lassoapp_link: 'browse/html/detail/default.lasso'),
		'browse/html/detail/dialog.lasso' = (lassoapp_link: 'browse/html/detail/dialog.lasso'),
		'browse/html/detail/library.lasso' = (lassoapp_link: 'browse/html/detail/library.lasso'),
		'browse/html/export/default.lasso' = (lassoapp_link: 'browse/html/export/default.lasso'),
		'browse/html/export/library.lasso' = (lassoapp_link: 'browse/html/export/library.lasso'),
		'browse/html/export/dialog.lasso' = (lassoapp_link: 'browse/html/export/dialog.lasso'),
		'browse/html/import/default.lasso' = (lassoapp_link: 'browse/html/import/default.lasso'),
		'browse/html/import/library.lasso' = (lassoapp_link: 'browse/html/import/library.lasso'),
		'browse/html/library.lasso' = (lassoapp_link: 'browse/html/library.lasso'),
		'browse/html/list/default.lasso' = (lassoapp_link: 'browse/html/list/default.lasso'),
		'browse/html/list/library.lasso' = (lassoapp_link: 'browse/html/list/library.lasso'),
		'browse/html/search/default.lasso' = (lassoapp_link: 'browse/html/search/default.lasso'),
		'browse/html/search/library.lasso' = (lassoapp_link: 'browse/html/search/library.lasso'),
		'browse/html/settings/default.lasso' = (lassoapp_link: 'browse/html/settings/default.lasso'),
		'browse/html/settings/library.lasso' = (lassoapp_link: 'browse/html/settings/library.lasso'),
		'browse/html/update/default.lasso' = (lassoapp_link: 'browse/html/update/default.lasso'),
		'browse/html/update/dialog.lasso' = (lassoapp_link: 'browse/html/update/dialog.lasso'),
		'browse/html/update/library.lasso' = (lassoapp_link: 'browse/html/update/library.lasso'),
		'browse/sql/statement/default.lasso' = (lassoapp_link: 'browse/sql/statement/default.lasso'),
		'browse/sql/statement/library.lasso' = (lassoapp_link: 'browse/sql/statement/library.lasso'),
		'build/databases/databases/default.lasso' = (lassoapp_link: 'build/databases/databases/default.lasso'),
		'build/databases/databases/dialog.lasso' = (lassoapp_link: 'build/databases/databases/dialog.lasso'),
		'build/databases/databases/library.lasso' = (lassoapp_link: 'build/databases/databases/library.lasso'),
		'build/databases/fields/default.lasso' = (lassoapp_link: 'build/databases/fields/default.lasso'),
		'build/databases/fields/dialog.lasso' = (lassoapp_link: 'build/databases/fields/dialog.lasso'),
		'build/databases/fields/library.lasso' = (lassoapp_link: 'build/databases/fields/library.lasso'),
		'build/databases/indices/default.lasso' = (lassoapp_link: 'build/databases/indices/default.lasso'),
		'build/databases/indices/dialog.lasso' = (lassoapp_link: 'build/databases/indices/dialog.lasso'),
		'build/databases/indices/library.lasso' = (lassoapp_link: 'build/databases/indices/library.lasso'),
		'build/databases/tables/default.lasso' = (lassoapp_link: 'build/databases/tables/default.lasso'),
		'build/databases/tables/dialog.lasso' = (lassoapp_link: 'build/databases/tables/dialog.lasso'),
		'build/databases/tables/library.lasso' = (lassoapp_link: 'build/databases/tables/library.lasso'),
		'images/LP7_WhiteLogo.gif' = (lassoapp_link: 'images/LP7_WhiteLogo.gif'),
		'images/logo_right.jpg' = (lassoapp_link: 'images/logo_right.jpg'),		
		'images/tab1_enabled_left.gif' = (lassoapp_link: 'images/tab1_enabled_left.gif'),		
		'images/tab1_enabled_right.gif' = (lassoapp_link: 'images/tab1_enabled_right.gif'),		
		'images/tab1_disabled_left.gif' = (lassoapp_link: 'images/tab1_disabled_left.gif'),		
		'images/tab1_disabled_right.gif' = (lassoapp_link: 'images/tab1_disabled_right.gif'),		
		'images/tab2_enabled_left.gif' = (lassoapp_link: 'images/tab2_enabled_left.gif'),		
		'images/tab2_enabled_right.gif' = (lassoapp_link: 'images/tab2_enabled_right.gif'),		
		'images/tab2_disabled_left.gif' = (lassoapp_link: 'images/tab2_disabled_left.gif'),		
		'images/tab2_disabled_right.gif' = (lassoapp_link: 'images/tab2_disabled_right.gif'),		
		'images/tab3_enabled_left.gif' = (lassoapp_link: 'images/tab3_enabled_left.gif'),		
		'images/tab3_enabled_right.gif' = (lassoapp_link: 'images/tab3_enabled_right.gif'),		
		'images/tab3_disabled_left.gif' = (lassoapp_link: 'images/tab3_disabled_left.gif'),		
		'images/tab3_disabled_right.gif' = (lassoapp_link: 'images/tab3_disabled_right.gif'),		
		'images/lassopower.gif' = (lassoapp_link: 'images/lassopower.gif'),		
	);
	
	define_tag: 'admin_link', -required='link';
		if: $admin_link_map->(find: #link) != null;
			return: $admin_link_map->(find: #link);
		else;
			return: (lassoapp_link: #link);
		/if;
	/define_tag;
	
	if: (var_defined:'admin_file')==false;
		var:'admin_file'=(LassoApp_Link:'default.lasso');
	/if;
	
	if:(var_defined:'dialog_file')==false;
		var:'dialog_file'=(LassoApp_Link: 'dialog.lasso');
	/if;

//	if: (var_defined:'help_file')==false;
//		var:'help_file'=(LassoApp_Link:'help.lasso');
//	/if;
	
	var: 'admin_link' = $admin_file +
		'?tab1=' + $admin_tab1 +
		'&tab2=' + $admin_tab2 +
		'&tab3=' + $admin_tab3 +
		'&-session=_browse:' + (session_id: -name='_browse') +
		'&increment=' + $admin_increment;

//	var: 'help_link' = $help_file +
//		'?tab1=' + $admin_tab1 +
//		'&tab2=' + $admin_tab2 +
//		'&tab3=' + $admin_tab3 +
//		'&-session=_browse:' + (session_id: -name='_browse') +
//		'&increment=' + $admin_increment;

	var: 'wide_stripe' = '#bfbfbf';

?>
