<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'browse_category_category';
session_addvar: -name='_reference', 'browse_category_maxrecords';
session_addvar: -name='_reference', 'browse_category_skiprecords';
session_addvar: -name='_reference', 'browse_category_found_count';
session_addvar: -name='_reference', 'browse_category_mode';
session_addvar: -name='_reference', 'browse_category_inline';

//
// Define Default Variables
//

if: (var_defined: 'browse_category_mode');

	//
	// Base Inline
	//

	variable: 'browse_category_inline' = $ref_tag_inline;

	//
	// Navigation Parameters
	//

	if: (var_defined: 'browse_category_navigation') && (var_defined: 'browse_category_found_count') && (var_defined: 'browse_category_skiprecords') && (var_defined: 'browse_category_maxrecords');
		if: ($browse_category_navigation >> 'Prev');
			var: 'temp' = (math_min: $browse_category_found_count, (math_max: 0, (math_sub: $browse_category_skiprecords, $browse_category_maxrecords)));
			$browse_category_inline->(insert: -SkipRecords=$temp);
		else: ($browse_category_navigation >> 'Next');
			var: 'temp' = (math_min: $browse_category_found_count, (math_max: 0, (math_add: $browse_category_skiprecords, $browse_category_maxrecords)));
			$browse_category_inline->(insert: -SkipRecords=$temp);
		/if;
	/if;

	//
	// Search Parameters
	//

	$browse_category_inline->(insert: -search='');
	$browse_category_inline->(insert: -maxrecords=15);
	$browse_category_inline->(insert: $ref_tag_display='Y');
	$browse_category_inline->(insert: $ref_tag_basic='Y');
	$browse_category_inline->(insert: -SortField=$ref_tag_category);
	$browse_category_inline->(insert: -SortField=$ref_tag_name);
	$browse_category_inline->(insert: $ref_tag_category=(var: 'browse_category_category'));

	//
	// Perform the Search
	//

	inline: $browse_category_inline, -inlinename='browse_category_results';
	  	var: 'browse_category_found_count' = (found_count);
	  	var: 'browse_category_shown_count' = (shown_count);
	  	var: 'browse_category_shown_first' = (shown_first);
	  	var: 'browse_category_shown_last' = (shown_last);
	  	var: 'browse_category_maxrecords' = (maxrecords_value);
	  	var: 'browse_category_skiprecords' = (skiprecords_value);
	/inline;
/if;

?>

