<?LassoScript

//
// Store Search Variables in Session
//

session_addvar: -name='_reference', 'commentsearch_action';
session_addvar: -name='_reference', 'commentsearch_tag';
session_addvar: -name='_reference', 'commentsearch_author';
session_addvar: -name='_reference', 'commentsearch_subject';
session_addvar: -name='_reference', 'commentsearch_comment';

session_addvar: -name='_reference', 'commentsearch_sort';
session_addvar: -name='_reference', 'commentsearch_maxrecords';
session_addvar: -name='_reference', 'commentsearch_skiprecords';
session_addvar: -name='_reference', 'commentsearch_found_count';
session_addvar: -name='_reference', 'commentsearch_mode';
session_addvar: -name='_reference', 'commentsearch_inline';

//
// Define Default Variables
//

variable_default: 'commentsearch_action', 'Search';
variable_default: 'commentsearch_sort', 'Name';

if: (action_param: 'commentsearch_mode') == 'Search';
	if: (action_param: 'commentsearch_tag') == '';
		var: 'commentsearch_tag'='';
	/if;
	if: (action_param: 'commentsearch_subject') == '';
		var: 'commentsearch_subject'='';
	/if;
	if: (action_param: 'commentsearch_author') == '';
		var: 'commentsearch_author'='';
	/if;
	if: (action_param: 'commentsearch_comment') == '';
		var: 'commentsearch_comment'='';
	/if;
/if;

if: ($commentsearch_action == 'Clear');
	var: 'commentsearch_subject'='';
	var: 'commentsearch_author'='';
	var: 'commentsearch_comment'='';
	var: 'commentsearch_tag'='';

	var: 'commentsearch_sort'='Date';
	var: 'commentsearch_found_count'=0;
/if;

if: (var_defined: 'commentsearch_mode');

	//
	// Base Inline
	//

	variable: 'commentsearch_inline' = $ref_comments_inline;

	//
	// Sorting Parameters
	//

	if: (var_defined: 'commentsearch_sort');
		if: ($commentsearch_sort >> 'Subject');
			$commentsearch_inline->(insert: -SortField=$ref_comments_subject);
			$commentsearch_inline->(insert: -SortField=$ref_comments_timestamp);
			$commentsearch_inline->(insert: -SortOrder='descending');
		else: ($commentsearch_sort >> 'Tag');
			$commentsearch_inline->(insert: -SortField=$ref_comments_tag_name);
			$commentsearch_inline->(insert: -SortField=$ref_comments_timestamp);
			$commentsearch_inline->(insert: -SortOrder='descending');
		else: ($commentsearch_sort >> 'Author');
			$commentsearch_inline->(insert: -SortField=$ref_comments_author);
			$commentsearch_inline->(insert: -SortField=$ref_comments_timestamp);
			$commentsearch_inline->(insert: -SortOrder='descending');
		else: ($commentsearch_sort >> 'Date');
			$commentsearch_inline->(insert: -SortField=$ref_comments_timestamp);
			$commentsearch_inline->(insert: -SortOrder='descending');
		/if;
	/if;

	//
	// Navigation Parameters
	//

	if: (var_defined: 'commentsearch_navigation') && (var_defined: 'commentsearch_found_count') && (var_defined: 'commentsearch_skiprecords') && (var_defined: 'commentsearch_maxrecords');
		if: ($commentsearch_navigation >> 'Prev');
			var: 'temp' = (math_min: $commentsearch_found_count, (math_max: 0, (math_sub: $commentsearch_skiprecords, $commentsearch_maxrecords)));
			$commentsearch_inline->(insert: -SkipRecords=$temp);
		else: ($commentsearch_navigation >> 'Next');
			var: 'temp' = (math_min: $commentsearch_found_count, (math_max: 0, (math_add: $commentsearch_skiprecords, $commentsearch_maxrecords)));
			$commentsearch_inline->(insert: -SkipRecords=$temp);
		/if;
	/if;

	//
	// Search Parameters
	//

	$commentsearch_inline->(insert: -search='');
	$commentsearch_inline->(insert: -maxrecords=10);

	if: ($commentsearch_action == 'Search');
		if: (var:'commentsearch_subject')!='';
			$commentsearch_inline->(insert: -op='cn');
			$commentsearch_inline->(insert: $ref_comments_subject=(var: 'commentsearch_subject'));
		/if;
		if: (var:'commentsearch_author')!='';
			$commentsearch_inline->(insert: -op='cn');
			$commentsearch_inline->(insert: $ref_comments_author=(var: 'commentsearch_author'));
		/if;
		if: (var:'commentsearch_comment')!='';
			$commentsearch_inline->(insert: -op='cn');
			$commentsearch_inline->(insert: $ref_comments_comments=(var: 'commentsearch_comment'));
		/if;
		if: (var:'commentsearch_tag')!='';
			$commentsearch_inline->(insert: -op='cn');
			$commentsearch_inline->(insert: $ref_comments_tag_name=(var: 'commentsearch_tag'));
		/if;
	/if;

	//
	// Perform the Search
	//
	if: ($commentsearch_action != 'Clear');
		inline: $commentsearch_inline, -inlinename='search';
			var: 'commentsearch_found_count' = (found_count);
			var: 'commentsearch_shown_count' = (shown_count);
			var: 'commentsearch_shown_first' = (shown_first);
			var: 'commentsearch_shown_last' = (shown_last);
			var: 'commentsearch_maxrecords' = (maxrecords_value);
			var: 'commentsearch_skiprecords' = (skiprecords_value);
		/inline;
	/if;
/if;

?>
