<?lassoscript

	// This file creates the following tags:
	// [Lasso_DatasourceIs]
	// [Lasso_DatasourceIsFileMaker]
	// [Lasso_DatasourceIsFileMakerSA]
	// [Lasso_DatasourceIsLassoMySQL]
	// [Lasso_DatasourceIsMySQL]
	// [Lasso_DatasourceIsJDBC]
	// [Lasso_DatasourceIsODBC]
	// [Lasso_DatasourceIs4D]



	// This is the parent for the [Lasso_DatasourceIs...] tags. It does all
	// the work.
	define_tag: 'Lasso_DatasourceIs',
		-priority = 'replace',
		-Required = 'Datasource',
		-Required = 'Name',
		-privileged;

		local: 'result';

		inline:
			-database = 'lasso_internal',
			-table = 'security_datasources',
			-sql = '\
				select \
					b.name as Datasource, \
					c.name as Host \
				from \
					security_datasource_databases as a \
					left join security_datasources as b on (a.id_datasource = b.id) \
					left join security_datasource_hosts as c on (a.id_host = c.id) \
				where \
					case \
						when a.alias is not null and length(a.alias) > 0 then \
							a.alias \
						else \
							a.name \
					end = \'' (encode_sql: #Name) '\'\
				';

			if: #Datasource == 'JDBC';
				#result = ((field: 'Datasource') >> #Datasource) || (field: 'Host')->(beginswith: 'jdbc');
			else;
				#result = (field: 'Datasource') == #Datasource;
			/if;

		/inline;

		return: #result;

	/define_tag;



	define_tag: 'Lasso_DatasourceIsFileMaker',
		-priority = 'replace',
		-optional = 'Name';

		local: 'result' = null;
		if: (local_defined: 'Name');
			#result = (Lasso_DatasourceIs: 'FMRemoteDataSource', #Name);
		/if;
		return: #result;

	/define_tag;



	define_tag: 'Lasso_DatasourceIsFileMakerSA',
		-priority = 'replace',
		-optional = 'Name';

		local: 'result' = null;
		if: (local_defined: 'Name');
			#result = (Lasso_DatasourceIs: 'FMServerAdvancedDataSource', #Name);
		/if;
		return: #result;

	/define_tag;



	define_tag: 'Lasso_DatasourceIsLassoMySQL',
		-priority = 'replace',
		-optional = 'Name';

		local: 'result' = null;
		if: (local_defined: 'Name');
			#result = (Lasso_DatasourceIs: 'InternalMySQLD', #Name);
		/if;
		return: #result;

	/define_tag;



	define_tag: 'Lasso_DatasourceIsMySQL',
		-priority = 'replace',
		-optional = 'Name';

		local: 'result' = null;
		if: (local_defined: 'Name');
			#result = (Lasso_DatasourceIs: 'MySQLDS', #Name);
		/if;
		return: #result;

	/define_tag;



	define_tag: 'Lasso_DatasourceIsJDBC',
		-priority = 'replace',
		-optional = 'Name';

		local: 'result' = null;
		if: (local_defined: 'Name');
			#result = (Lasso_DatasourceIs: 'JDBC', #Name);
		/if;
		return: #result;

	/define_tag;



	// works with the third-party CAPIODBC module
	define_tag: 'Lasso_DatasourceIsODBC',
		-priority = 'replace',
		-optional = 'Name';

		local: 'result' = null;
		if: (local_defined: 'Name');
			#result = (Lasso_DatasourceIs: 'CAPIODBC', #Name);
		/if;
		return: #result;

	/define_tag;



	// returns false, because it doesn't exist anymore
	define_tag: 'Lasso_DatasourceIs4D',
		-priority = 'replace',
		-optional = 'Name';
		return: false;
	/define_tag;
	
?>