<?LassoScript

	// This file is the only file called at startup by Lasso.
	// This file must include all other files in startup.lassoapp
	// which need to be called.

	Auth_Admin;

// Log Startup Message

	log_critical: 'Lasso Professional ' + (lasso_version: -lassoversion)->(substring: 1, (lasso_version: -lassoversion)->(find: ' ') - 1) + ' Started';

// Set Default Error Preferences

	protect;
		library: (lassoapp_link: 'errorDefaults.lasso');
		handle_error;
			log_critical: 'Error: errorDefaults.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Check/Repair Databases

	protect;
		library: (lassoapp_link: 'database_check.lasso');
		handle_error;
			log_critical: 'Error: database_check.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Load Lasso Tag Libraries

	Log_Warning: 'Lasso Tags: Defining Lasso 7 Tags';

	// File tags: file_getlinecount, file_readline
	protect;
		library: (lassoapp_link: 'file_tags.lasso');
		handle_error;
			log_critical: 'Error: file_tags.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Global variable tags [Global] [Global_Defined]
	protect;
		library: (lassoapp_link: 'globals.lasso');
		handle_error;
			log_critical: 'Error: globals.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Cache tags [Cache] ... [/Cache] [Cache_Object]
	protect;
		library: (lassoapp_link: 'Cache.lasso');
		handle_error;
			log_critical: 'Error: Cache.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Security Tags
	protect;
		library: (lassoapp_link: 'security.lasso');
		handle_error;
			log_critical: 'Error: security.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Utility Tags [Named_Param] [Client_...] tags
	protect;
		library: (lassoapp_link: 'utility.lasso');
		handle_error;
			log_critical: 'Error: utility.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// [Datasource_Is...] tags
	protect;
		library: (lassoapp_link: 'DatasourceIs.lasso');
		handle_error;
			log_critical: 'Error: DatasourceIs.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Lasso MySQL table/field creation tags
	protect;
		library: (lassoapp_link: 'tableGoodiesLibrary.lasso');
		handle_error;
			log_critical: 'Error: tableGoodiesLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Link tags
	protect;
		library: (lassoapp_link: 'link_tags.lasso');
		handle_error;
			log_critical: 'Error: link_tags.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Valdiation Tags tags
	protect;
		library: (lassoapp_link: 'valid.lasso');
		handle_error;
			log_critical: 'Error: valid.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Lasso [..._Serve] Tags
	protect;
		library: (lassoapp_link: 'serveLibrary.lasso');
		handle_error;
			log_critical: 'Error: serveLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Lasso Professional 6 Semephores, Pipes, and Read/Write Locks
	protect;
		library: (lassoapp_link: 'thread_semaphore.lasso');
		handle_error;
			log_critical: 'Error: thread_semaphore.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;
	protect;
		library: (lassoapp_link: 'thread_pipe.lasso');
		handle_error;
			log_critical: 'Error: thread_pipe.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;
	protect;
		library: (lassoapp_link: 'thread_rwlock.lasso');
		handle_error;
			log_critical: 'Error: thread_rwlock.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Lasso [XML_...] Tags
	protect;
		library: (lassoapp_link: 'xml_tags.lasso');
		handle_error;
			log_critical: 'Error: xml_tags.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Load Lasso 3 Compatibility Tag Libraries

	Log_Warning: 'Lasso Tags: Defining Lasso 3 Compatibility Tags';

	// Lasso 3 compatibility types [Repetition], [Client_Address] [Client_IP]
	protect;
		library: (lassoapp_link: 'compatibility.lasso');
		handle_error;
			log_critical: 'Error: compatibility.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Lasso 3 compatibility tags [Math_ConvertEuro], etc.
	protect;
		library: (lassoapp_link: 'MiscLibrary.lasso');
		handle_error;
			log_critical: 'Error: MiscLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Lasso 3 list tags
	protect;
		library: (lassoapp_link: 'list_tags.lasso');
		handle_error;
			log_critical: 'Error: list_tags.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// The [Stock_Quote] example tag.
	protect;
		library: (lassoapp_link: 'tcpGoodiesLibrary.lasso');
		handle_error;
			log_critical: 'Error: tcpGoodiesLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Locale tags
	protect;
		library: (lassoapp_link: 'locale.lasso');
		handle_error;
			log_critical: 'Error: locale.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Image tags (Stub if X11 is missing)
	protect;
		library: (lassoapp_link: 'image_tags.lasso');
		handle_error;
			log_critical: 'Error: image_tags.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Create Utility Tables and Start Background Processes

	// Session tracker table in site database
	protect;
		library: (lassoapp_link: 'sessiontrackerinit.lasso');
		handle_error;
			log_critical: 'Error: sessiontrackerinit.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Create preferences table and define helper tags
	protect;
		library: (lassoapp_link: 'LassoAdminStartup.lasso');
		handle_error;
			log_critical: 'Error: LassoAdminStartup.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Email Queue and [Email_Send] tag

	protect;
		library: (lassoapp_link: 'smtpLibrary.lasso');
		_SMTP_Init;
		_SMTP_EmailWatcher;
		handle_error;
			log_critical: 'Error: smtpLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Turn on Strict Syntax
	protect;
		library: (lassoapp_link: 'StrictSyntax.lasso');
		handle_error;
			log_critical: 'Error: StrictSyntax.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Maintenance Queue
	// Requires: LassoAdminStarutp.LassoApp
	protect;
		library: (lassoapp_link: 'maintenanceLibrary.lasso');
		handle_error;
			log_critical: 'Error: maintenanceLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// Schedule Queue and [Event_Schedule] tag
	protect;
		library: (lassoapp_link: 'scheduleLibrary.lasso');
		handle_error;
			log_critical: 'Error: scheduleLibrary.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// XML_RPC type
	protect;
		library: (lassoapp_link: 'xml_rpc.lasso');
		handle_error;
			log_critical: 'Error: xml_rpc.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

	// RPC Introspection
	protect;
		library: (lassoapp_link: 'RPC_introspect.lasso');
		handle_error;
			log_critical: 'Error: RPC_introspect.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Lasso Security

	// Load Lasso Security Modifications
	protect;
		library: (lassoapp_link: 'LassoSecurity.lasso');
		handle_error;
			log_critical: 'Error: LassoSecurity.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Set Error Preferences (defaults used until this point)

	protect;
		library: (lassoapp_link: 'errorSetup.lasso');
		handle_error;
			log_critical: 'Error: errorSetup.lasso';
			log_critical: error_code ': ' error_msg;
			error_code = 0;
			error_msg = '';
		/handle_error;
	/protect;

// Reload internal data source, and Dump Startup.LassoApp

	// Ensure that any altered database tables are loaded
	_datasource_reload: 1;

	// Call lassoapp_dump asynchronously so it occurs after we finish executing.
	{ Sleep: 15000; LassoApp_Dump: 'Startup.LassoApp' }->AsAsync;

?>
