<?LassoScript
	// This startup script is enclosed in a compound expression so the variables will not
	// show up in the list of global variables.
	{

		Log_Warning: 'Lasso Errors: Setting Default Preferences';

		local: 'critical_set' = false;
		local: 'detail_set' = false;
		local: 'warning_set' = false;

		variable: '_log_settings' = (array);

		//
		// Search for preferences
		//

		inline: -database='lasso_internal', -table='global_prefs', -search, -op='bw', 'store_key'='log';
			records;

				local: 'key' = (integer: (field: 'data'));
				local: 'file' = 0;
				local: 'database' = 0;
				local: 'console' = 0;
				local: 'level' = null;

				if: #key->(bittest: 1);
					local: 'console' = log_destination_console;
				/if;
				if: #key->(bittest: 2);
					local: 'file' = log_destination_file;
				/if;
				if: #key->(bittest: 3);
					local: 'database' = log_destination_database;
				/if;

				if: (field: 'store_key') == 'log_critical_dest';
					local: 'level' = log_level_critical;
					local: 'critical_set' = true;
				else: (field: 'store_key') == 'log_detail_pref';
					local: 'level' = log_level_detail;
					local: 'detail_set' = true;
				else: (field: 'store_key') == 'log_warning_dest';
					local: 'level' = log_level_warning;
					local: 'warning_set' = true;
				/if;

				$_log_settings->(insert: (array: #level, #file, #database, #console));

			/records;
		/inline;

		//
		// Defaults if no preferences stored
		//

		if: (local: 'critical_set') != true;
			$_log_settings->(insert: (array: log_level_critical, log_destination_file, log_destination_database, log_destination_console));
		/if;

		if: (local: 'detail_set') != true;
			$_log_settings->(insert: (array: log_level_detail, 0, 0, log_destination_console));
		/if;

		if: (local: 'warning_set') != true;
			$_log_settings->(insert: (array: log_level_warning, 0, 0, log_destination_console));
		/if;
		
		//
		// Defaults for Startup.LassoApp
		//
		
		log_setdestination: log_level_critical, log_destination_file, log_destination_database, log_destination_console;
		log_setdestination: log_level_detail, 0, 0, 0;
		log_setdestination: log_level_warning, 0, 0, log_destination_console;

	}->(run);
		
?>