<?LassoScript

// Global.lasso
//
// This file defines two tags which make working with global variables easier
//
// [Global] can be used to set and retrieve global variables like [Variable].
// [Global_Defined] can be used to check whether a global has been defined.
//

define_tag: 'global', -priority='replace';
	iterate: (params), (local: 'param');
		if: (#param->(isa: 'pair'));
				globals->(insert: #param->first = #param->second);
		else;
			if: !(globals->keys >> #param);
				globals->(insert: #param = null);
			/if;
			return: (globals->(find: #param));
		/if;
	/iterate;
/define_tag;

define_tag: 'global_defined', -required='param', -priority='replace';
	if: (globals->keys >> #param);
		return: true;
	/if;
	return: false;
/define_tag;

define_tag: 'global_remove', -required='param', -priority='replace';
	globals->(remove: #param);
/define_tag;

// some tag constants
define_tag: 'bom_utf8';
	 return: (bytes->import8Bits(0xEF) & import8Bits(0xBB) & import8Bits(0xBF) &);
/define_tag;

define_tag: 'bom_utf16be';
	 return: (bytes->import8Bits(0xFE) & import8Bits(0xFF) &);
/define_tag;

define_tag: 'bom_utf16le';
	 return: (bytes->import8Bits(0xFF) & import8Bits(0xFE) &);
/define_tag;

define_tag: 'bom_utf32le';
	 return: (bytes->import8Bits(0xFF) & import8Bits(0xFE) & import16Bits(0x0000) &);
/define_tag;

define_tag: 'bom_utf32be';
	 return: (bytes->import16Bits(0x0000) & import8Bits(0xFE) & import8Bits(0xFF) &);
/define_tag;

?>